define([
    'app',

    'run/onRun.clique_mbmauth',

    'routes/giftcardRoutes',
    'routes/kidsRoutes',

    'resolvers/giftcardResolver',

    'resources/giftcard_occasion_options',
    'resources/kids_guardian_options',

    'services/giftcardService',
    'services/giftcardUtilService',

    'directives/maximumAge',
    'directives/minimumAge',

    'controllers/giftcard/giftcardCheckoutController',
    'controllers/giftcard/giftcardCustomerController',
    'controllers/giftcard/giftcardListController',
    'controllers/giftcard/giftcardPromocodeController',
    'controllers/giftcard/giftcardRecipientsController',
    'controllers/giftcard/giftcardReminderController',
    'controllers/giftcard/giftcardConfirmationController',
    'controllers/giftcard/giftcardWelcomeController',
    'controllers/kids/kidsBenefitsController',
    'controllers/kids/kidsController',
    'controllers/loyalty/loyaltyDetailController',
    'controllers/loyalty/loyaltyTransactionsController',
    'controllers/loyalty/loyaltyVouchersController',
    'controllers/user/completeRegistrationController',
    'controllers/user/facebookUserActivateController',

], function (
    app,

    onRunClique_Mbmauth,

    giftcardRoutes,
    kidsRoutes,

    giftcardResolver,

    giftcard_occasion_options,
    kids_guardian_options,

    giftcardService,
    giftcardUtilService,

    maximumAge,
    minimumAge,

    giftcardCheckoutController,
    giftcardCustomerController,
    giftcardListController,
    giftcardPromocodeController,
    giftcardRecipientsController,
    giftcardReminderController,
    giftcardConfirmationController,
    giftcardWelcomeController,
    kidsBenefitsController,
    kidsController,
    loyaltyDetailController,
    loyaltyTransactionsController,
    loyaltyVouchersController,
    completeRegistrationController,
    facebookUserActivateController
) {
        app.config(giftcardRoutes);
        app.config(kidsRoutes);

        app.constant('giftcard_occasion_options', giftcard_occasion_options);
        app.constant('kids_guardian_options', kids_guardian_options);

        app.service('giftcardResolver', giftcardResolver);

        app.service('giftcardService', giftcardService);
        app.service('giftcardUtilService', giftcardUtilService);

        app.directive('maximumAge', maximumAge);
        app.directive('minimumAge', minimumAge);

        app.controller('giftcardCheckoutController', giftcardCheckoutController);
        app.controller('giftcardCustomerController', giftcardCustomerController);
        app.controller('giftcardListController', giftcardListController);
        app.controller('giftcardPromocodeController', giftcardPromocodeController);
        app.controller('giftcardRecipientsController', giftcardRecipientsController);
        app.controller('giftcardReminderController', giftcardReminderController);
        app.controller('giftcardConfirmationController', giftcardConfirmationController);
        app.controller('giftcardWelcomeController', giftcardWelcomeController);

        app.controller('kidsBenefitsController', kidsBenefitsController);
        app.controller('kidsController', kidsController);

        app.controller('loyaltyDetailController', loyaltyDetailController);
        app.controller('loyaltyTransactionsController', loyaltyTransactionsController);
        app.controller('loyaltyVouchersController', loyaltyVouchersController);

        app.controller('completeRegistrationController', completeRegistrationController);
        app.controller('facebookUserActivateController', facebookUserActivateController);

        app.run(onRunClique_Mbmauth);
    });
