define(['bugsnag'], function (bugsnag) {
    var angular = function ($animateProvider, $provide, $compileProvider, $locationProvider, tmhDynamicLocaleProvider, config_constants) {
        $locationProvider.hashPrefix('!'); // Used for SEO with prerender.io
        // Disable debug info
        if (!config_constants.debug) $compileProvider.debugInfoEnabled(false);
        $compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|geo|tel):/);
        $animateProvider.classNameFilter(/^((?!(fa-pulse)).)*$/); // Angular Animate clashes with Font Awesome animations

        $provide.decorator('$exceptionHandler', ['$delegate', function ($delegate) {
            var bugsnagClient = bugsnag({
                apiKey: '1d0d5ab84e29666e74e857195b8f8713',
                metaData: config_constants,
                releaseStage: config_constants.debug ? 'development' : 'production',
                notifyReleaseStages: ['production']
            });


            return function (exception, cause) {
                var exceptionsToIgnore = ['Possibly unhandled rejection: canceled'];
                if (_.includes(exceptionsToIgnore, exception)) return;

                bugsnagClient.notify(exception);
                $delegate(exception, cause);
            };
        }]);

        tmhDynamicLocaleProvider.localeLocationPattern('lib/angular-locale_{{locale}}.js');
    };

    angular.$inject = ['$animateProvider', '$provide', '$compileProvider', '$locationProvider', 'tmhDynamicLocaleProvider', 'config_constants'];
    return angular;
});
