define([], function () {
    var angularAgility = function (aaFormExtensionsProvider) {
        aaFormExtensionsProvider.labelStrategies.muullaAppLabel = function ($element, labelText, isRequired) { };
        aaFormExtensionsProvider.defaultLabelStrategy = 'muullaAppLabel';

        aaFormExtensionsProvider.fieldGroupStrategies.muullaAppInput = function ($element) {
            $element.wrap('<ion-input class="item item-input"></ion-input>');
            if ($element[0].tagName == 'SELECT') {
                $element.parent()
                    .addClass('item-select')
                    .prepend('<div class="input-label">' + $element.attr('aa-label') + '</div>');
            }
        };
        aaFormExtensionsProvider.defaultFieldGroupStrategy = 'muullaAppInput';

        aaFormExtensionsProvider.defaultOnNavigateAwayStrategy = 'none';

        aaFormExtensionsProvider.validationMessages = {
            required: 'Required.',
            email: 'Invalid email.',
            minlength: 'Insert at least {1} characters.',
            maxlength: 'Insert less than {1} characters.',
            min: 'Must be at least {1}.',
            max: 'Must be at most {1}.',
            pattern: 'Invalid pattern.',
            url: 'Invalid URL.',
            number: 'Invalid number.',
            integer: 'Must be integer.',
            passwordPolicy: 'Password must have at least 1 alphabetical and numeric character.',
            ccNumber: 'Invalid card number.',
            ccNumberType: 'Invalid card type.',
            ccCvc: 'Invalid CVV/CID format.',
            unknown: 'Invalid.'
        };

        aaFormExtensionsProvider.valMsgPlacementStrategies.muullaAppValMsg = function ($element, formName, formFieldName) {
            var msgElement = angular.element('<div aa-val-msg-for="' + formName + '.' + formFieldName + '"></div>');
            if ($element[0].tagName == 'DIV') { // Used by intlpnIonic
                $element.after(msgElement);
            } else {
                $element.parent().after(msgElement);
            }
            return msgElement;
        };
        aaFormExtensionsProvider.defaultValMsgPlacementStrategy = 'muullaAppValMsg';

        // Show only the first error
        aaFormExtensionsProvider.valMsgForTemplate = '<div class="error-msg" ng-show="showMessages && errorMessages.length > 0">{{errorMessages[0] | i18n}}</div>';
    };

    angularAgility.$inject = ['aaFormExtensionsProvider'];
    return angularAgility;
});