define([], function () {
    var advertListController = function ($rootScope, $scope, $timeout, $state, advertsFetcher, frameworkService) {
        frameworkService.showBackButton($scope);

        var stateName = $state.current.name;
        var reloadAdverts = function () {
            if (!$state.is(stateName)) // This controller is used in many views that can be cached by Ionic. So we only reload the adverts on the current view
                return;
            // frameworkService.doRefresh(); TODO: Use this when refresh for caching views is working
            $scope.moreDataCanBeLoaded = false;
            advertsFetcher.reset()
                .then(function () {
                    $timeout(function () {
                        $scope.moreDataCanBeLoaded = true;
                        $scope.adverts = [];
                        frameworkService.scrollTop();
                    });
                });
        };

        $scope.moreDataCanBeLoaded = true;
        $scope.adverts = [];
        $scope.loadMoreData = function () {
            frameworkService.loadMoreData($scope, advertsFetcher)
                .then(function (response) {
                    if (response != null) {
                        _.forEach(response.data, function (instance) {
                            instance.advert.instance_id = instance._id;
                            instance.advert.location = instance.location;
                            $scope.adverts.push(instance.advert);
                        });
                    }
                });
        };

        var sortWatcher = $rootScope.$on('sorting:changed', reloadAdverts);
        var radiusWatcher = $rootScope.$on('radius:changed', reloadAdverts);

        $scope.$on('$destroy', function () {
            sortWatcher();
            radiusWatcher();
        });
    };

    advertListController.$inject = ['$rootScope', '$scope', '$timeout', '$state', 'advertsFetcher', 'frameworkService'];
    return advertListController;
});
