define([], function () {
    var categoryListController = function ($scope, categoriesFetcher, frameworkService, i18nFilter, parentCategoryResponse) {
        $scope.title = _.get(parentCategoryResponse, 'data.name') ? parentCategoryResponse.data.name : i18nFilter('Categories');

        $scope.moreDataCanBeLoaded = true;
        $scope.categories = [];
        $scope.loadMoreData = function () {
            frameworkService.loadMoreData($scope, categoriesFetcher)
                .then(function (response) {
                    if (response != null) {
                        $scope.categories = $scope.categories.concat(response.data);
                    }
                });
        };

        $scope.categoryClicked = function (category) {
            if (!category.is_parent) {
                frameworkService.navigateTo('advertListByCategory', {
                    _id: category._id
                });
            } else {
                frameworkService.navigateTo('categoryListById', {
                    _id: category._id
                });
            }
        };
    };

    categoryListController.$inject = ['$scope', 'categoriesFetcher', 'frameworkService', 'i18nFilter', 'parentCategoryResponse'];
    return categoryListController;
});
