define([], function () {
    var giftcardConfirmationController = function ($scope, $window, $stateParams, giftcardResponse, frameworkService, taggingService, giftcardUtilService, config_constants, utilityService, fencingService) {
        $scope.status = $stateParams.status;
        var giftcardDetails = giftcardResponse.data;
        var totalNet = _.round(giftcardDetails.total_net / 100, 2);
        if (totalNet) giftcardUtilService.clearGiftcards();  // only clear giftcard once you get the information needed for the tagging events

        if ((_.isEmpty($scope.status)) || ($scope.status != 'success' && $scope.status != 'error')) return frameworkService.navigateTo('giftcardWelcome');

        // dataLayer tagging
        if ($scope.status === 'success') taggingService.pushEvent('giftcardConfirmationCompleted', { 'amount': totalNet });

        // appsflyer mobile event triggered
        if ($window.plugins && $window.plugins.appsFlyer) {
            var eventName = '';
            var eventValues = {};
            if ($scope.status === 'success') {
                eventName = 'af_purchase';
                eventValues = {
                    'af_currency': utilityService.getCurrency(fencingService.getCountry()),
                    'af_revenue': totalNet
                };
            } else if ($scope.status === 'error') {
                eventName = 'gc_purchase_failure';
                eventValues = {};
            }
            $window.plugins.appsFlyer.trackEvent(eventName, eventValues);
        }
    };

    giftcardConfirmationController.$inject = ['$scope', '$window', '$stateParams', 'giftcardResponse', 'frameworkService', 'taggingService', 'giftcardUtilService', 'config_constants', 'utilityService', 'fencingService'];
    return giftcardConfirmationController;
});
