define([], function () {
    var giftcardRecipientsController = function ($scope, frameworkService, giftcardService, giftcardUtilService, giftcard_occasion_options, response_enum, taggingService) {
        var giftcards = giftcardUtilService.getGiftcards();

        if (_.isEmpty(giftcards.merchant)) {
            return frameworkService.navigateTo('giftcardWelcome');
        }

        giftcardService.getAllGiftcardAmounts().then(function (response) {
            if (response.response_code === response_enum.CODE.SUCCESS) {
                $scope.amounts = response.data.giftcard_amounts;
            } else {
                frameworkService.showError(response.data);
            }
        });

        $scope.occasions = giftcard_occasion_options;

        $scope.recipients = angular.copy(giftcards.recipients) || [];

        $scope.addRecipient = function () {
            var recipient = {
                first_name: null,
                last_name: null,
                email: null,
                mobile: null,
                occasion: null,
                original_amount: null,
                amount: null
            };
            $scope.recipients.push(recipient);
        };

        if (_.size($scope.recipients) === 0) {
            $scope.addRecipient();
        }

        $scope.removeRecipient = function (index) {
            $scope.recipients.splice(index, 1);
        };

        $scope.next = function () {
            giftcards.recipients = $scope.recipients;
            _.forEach(giftcards.recipients, function (recipient) {
                recipient.amount = recipient.original_amount;
                taggingService.pushEvent('giftCardNext', { 'amount': _.round(recipient.amount / 100, 2), 'url': window.location.hash });
            });

            giftcardUtilService.setGiftcards(giftcards);
            frameworkService.navigateTo('giftcardCheckout');
        };
    };

    giftcardRecipientsController.$inject = ['$scope', 'frameworkService', 'giftcardService', 'giftcardUtilService', 'giftcard_occasion_options', 'response_enum', 'taggingService'];
    return giftcardRecipientsController;
});
