define([], function () {
    var giftcardReminderController = function ($scope, moment, frameworkService, giftcardService, giftcard_occasion_options, response_enum) {
        $scope.reminder = {
            recipient: {
                first_name: null,
                last_name: null
            },
            occasion: null,
            send: {
                email: false,
                sms: false
            }
        };

        $scope.hours = [];
        for (var hour = 0; hour < 24; hour++) {
            var momentHour = moment().startOf('day').add(hour, 'hour');
            $scope.hours.push(momentHour);
            if (hour === 9) {
                $scope.reminder.hour = momentHour;
            }
        }

        var today = moment().startOf('day');
        $scope.datepickerOptions = frameworkService.getDatepickerOptions({
            start: moment(today).add(1, 'day'),
            end: moment(today).add(5, 'year'),
            date: moment(today).add(1, 'year')
        });

        $scope.occasions = giftcard_occasion_options;

        $scope.submit = function () {
            if (!$scope.reminder.send.email && !$scope.reminder.send.sms) {
                frameworkService.showAlert('Select at least one sending method.');
                return;
            }
            var data = {
                date_selected: moment($scope.datepickerOptions.inputDate).set('hour', $scope.reminder.hour.get('hours')).toISOString(),
                recipient: $scope.reminder.recipient,
                occasion: $scope.reminder.occasion,
                send: $scope.reminder.send
            };
            giftcardService.setReminder(data).then(function (response) {
                if (response.response_code === response_enum.CODE.SUCCESS) {
                    frameworkService.showToast('Reminder set');
                    frameworkService.navigateToHome();
                } else {
                    frameworkService.showError(response.data);
                }
            });
        };
    };

    giftcardReminderController.$inject = ['$scope', 'moment', 'frameworkService', 'giftcardService', 'giftcard_occasion_options', 'response_enum'];
    return giftcardReminderController;
});
