define([], function () {
    var giftcardWelcomeController = function ($scope, giftcardUtilService, merchantService, settingsService, response_enum, frameworkService) {
        var giftcards = giftcardUtilService.getGiftcards();

        merchantService.getMerchants(10, 1).then(function (response) {
            giftcards.merchant = _.head(response.data)._id; // Currently gifting only caters single merchant instances
            giftcardUtilService.setGiftcards(giftcards);
        });

        $scope.openGiftingTerms = function () {
            settingsService.getGiftCardTerms().then(function (response) {
                if (response.response_code === response_enum.CODE.SUCCESS) {
                    $scope.terms = response.data;
                    frameworkService.showModal($scope, 'views/giftcard/giftcardTermsModal.html');
                } else {
                    frameworkService.showError(response.data);
                }
            });
        };
    };

    giftcardWelcomeController.$inject = ['$scope', 'giftcardUtilService', 'merchantService', 'settingsService', 'response_enum', 'frameworkService'];
    return giftcardWelcomeController;
});
