define([], function () {
    var loyaltyDetailController = function ($scope, loyaltyResponse, userResponse, config_constants, utilityService) {
        $scope.user = _.get(loyaltyResponse, 'data');
        $scope.availableVouchersCount = _.filter(_.get(loyaltyResponse, 'data.issued_vouchers'), function (voucher) {
            return voucher.status === 'available';
        }).length;

        if ($scope.user) {
            $scope.user.avatar = _.defaultTo(_.get(userResponse, 'data.avatar'), null);
            $scope.user.clique_id = _.get(_.find(_.get($scope.user, 'additional_data'), {
                key: 'clique_id'
            }), 'value');

            angular.element(function () {  // wait for html to be loaded first before appending to #id
                if (config_constants.loyalty.qr) {
                    utilityService.generateQRcode('qr', $scope.user.clique_id);
                }
            });
        }

    };

    loyaltyDetailController.$inject = ['$scope', 'loyaltyResponse', 'userResponse', 'config_constants', 'utilityService'];
    return loyaltyDetailController;
});