define([], function () {
    var loyaltyTransactionsController = function ($scope, loyaltyResponse, transactionsResponse, frameworkService, i18nFilter, loyaltyService, response_enum) {
        $scope.user = loyaltyResponse.data;
        $scope.transactions = transactionsResponse.data;
        $scope.page = 0;

        $scope.openPopup = function (transaction) {
            $scope.transaction = transaction;
            frameworkService.showPopup({
                templateUrl: 'views/loyalty/transactionDetail.html',
                title: i18nFilter('Transaction receipt'),
                scope: $scope,
                buttons: [{
                    text: i18nFilter('OK'),
                    type: 'button-balanced'
                }]
            });
        };

        $scope.getCurrentTransactions = function () {
            $scope.transactions = transactionsResponse.data;
        };

        $scope.getArchivedTransactions = function () {
            loyaltyService.getArchivedTransactions().then(function (response) {
                if (response.response_code === response_enum.CODE.SUCCESS) {
                    $scope.transactions = response.data;
                } else {
                    const msg = _.get(_.head(response.data), 'message'); // Display the error msg even if it's not expected (Clique integration is unpredictable)
                    if (!_.isEmpty(msg)) {
                        frameworkService.showAlert(msg);
                    } else {
                        frameworkService.showError(response.data);
                    }
                }
            });
        };

    };

    loyaltyTransactionsController.$inject = ['$scope', 'loyaltyResponse', 'transactionsResponse', 'frameworkService', 'i18nFilter', 'loyaltyService', 'response_enum'];
    return loyaltyTransactionsController;
});
