define([], function () {
    var loyaltyVouchersController = function ($scope, loyaltyService) {
        var vouchers;
        loyaltyService.getLoyaltyDetails().then(function (response) {
            vouchers = _.get(response, 'data.issued_vouchers');
            $scope.status = 'available';
            $scope.filterByStatus($scope.status);
        });

        $scope.filterByStatus = function (status) {
            switch (status) {
                case 'available':
                    $scope.vouchers = _.filter(vouchers, function (voucher) {
                        return voucher.status === 'available';
                    });
                    break;
                case 'used':
                    $scope.vouchers = _.filter(vouchers, function (voucher) {
                        return voucher.status === 'redeemed' || voucher.status === 'blocked voucher' || voucher.status === 'unblocked';
                    });
                    break;
                case 'expired':
                    $scope.vouchers = _.filter(vouchers, function (voucher) {
                        return voucher.status === 'expired';
                    });
                    break;
            }
        };
    };

    loyaltyVouchersController.$inject = ['$scope', 'loyaltyService'];
    return loyaltyVouchersController;
});