define([], function () {
    var itemDetailController = function ($scope, $state, config_constants, frameworkService) {
        $scope.item.selected.notes ? $scope.showNotesInput = true : $scope.showNotesInput = false;

        // In Ionic the itemId doesn't get populated in href. That's why we need to add it manually
        $scope.shareUrl = config_constants.webappUrl + '/' + $state.href('menuItem', { item_id: null }) + $scope.item._id;
        var validateAddonGroups = function () {
            var isValidAddonGroups = true;
            _.forEach($scope.item.addon_groups, function (addon_group) {
                var selectedCount = _.size(_.filter(addon_group.addons, 'checked'));
                addon_group.isValid = selectedCount >= (addon_group.min_selections || 0) && selectedCount <= (addon_group.max_selections || Infinity);
                if (!addon_group.isValid) {
                    isValidAddonGroups = false;
                }
            });
            $scope.form.$setValidity('addon_groups', isValidAddonGroups);
        };

        $scope.$watch('form', function () {
            validateAddonGroups();
        });

        $scope.onAddonChecked = function (addon_group, addon) {
            if (addon_group.min_selections == addon_group.max_selections) {
                var group = _.filter($scope.item.addon_groups, addon_group);
                var selectedCount = _.size(_.filter(addon_group.addons, 'checked'));
                var valid = selectedCount >= (group[0].min_selections || 0) && selectedCount <= (group[0].max_selections || Infinity);

                if (!valid) {
                    _.forEach(_.filter(group[0].addons, 'checked'), function (addon) {
                        addon.checked = false;
                    });
                    var addOnToCheck = _.filter(group[0].addons, addon);
                    addOnToCheck[0].checked = true;
                }
            }

            var selectedAddons = _.map(_.filter(addon_group.addons, 'checked'), function (selectedAddon) {
                return {
                    name: selectedAddon.name,
                    notes: selectedAddon.notes,
                    variant: selectedAddon.variant_group.variants[0],
                    quantity: 1
                };
            });

            var selectedAddonGroup = _.find($scope.item.selected.addon_groups, {
                name: addon_group.name
            });
            if (!selectedAddonGroup) {
                selectedAddonGroup = {
                    name: addon_group.name,
                    addons: []
                };
                $scope.item.selected.addon_groups.push(selectedAddonGroup);
            }
            selectedAddonGroup.addons = selectedAddons;
            validateAddonGroups();
        };

        $scope.isGroupShown = function (key) {
            return $scope.shownGroup === key;
        };

        $scope.toggleGroup = function (key) {
            $scope.shownGroup = $scope.isGroupShown(key) ? null : key;
        };
        $scope.toggleGroup('extras');
    };

    itemDetailController.$inject = ['$scope', '$state', 'config_constants', 'frameworkService'];
    return itemDetailController;
});
