define([], function () {
    var fencingController = function ($rootScope, $scope, fencingService, radius_options, sorting_options, response_enum) {
        //init for sorting objects
        $scope.sorting_options = sorting_options;
        $scope.currentSortingCriteria = fencingService.getSortingCriteria();

        //init for radius objects
        $scope.radius_options = radius_options;
        $scope.currentRadius = fencingService.getRadius();

        $scope.onSortingChange = function () {
            fencingService.setSortingCriteria($scope.currentSortingCriteria);
        };

        $scope.onRadiusChange = function () {
            fencingService.setRadius($scope.currentRadius);
        };

        var sortWatcher = $rootScope.$on('sorting:changed', function (event, value) {
            $scope.currentSortingCriteria = value;
        });
        var radiusWatcher = $rootScope.$on('radius:changed', function (event, value) {
            $scope.currentRadius = value;
        });

        var onGeolocationDisabled = function () {
            // Select a sorting criteria other than 'distance'
            $scope.sorting_options = _.filter(sorting_options, function (sorting) { return sorting._id !== 'distance'; });
            fencingService.setSortingCriteria(_.head($scope.sorting_options)._id);

            // Set the default radius to the maximum so it displays the adverts
            fencingService.setRadius(_.last(radius_options)._id);
        };
        if (!$rootScope.geolocationEnabled) {
            onGeolocationDisabled();
        }
        var geolocationWatcher = $rootScope.$on('geolocation:disabled', onGeolocationDisabled);

        $scope.$on('$destroy', function () {
            sortWatcher();
            radiusWatcher();
            geolocationWatcher();
        });
    };

    fencingController.$inject = ['$rootScope', '$scope', 'fencingService', 'radius_options', 'sorting_options', 'response_enum'];
    return fencingController;
});
