define([], function () {
    var headerTitleController = function ($scope, frameworkService, headerTitleService, config_constants) {
        $scope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
            var statesWithDropdown = [
                'categoryList',
                'locationList',
                'merchantList'
            ];
            $scope.showDropdown = !config_constants.isSingleMerchant && _.some(statesWithDropdown, function (item) {
                return toState.name === item;
            });

            if ($scope.showDropdown) {
                $scope.menu = headerTitleService.getMenu();
            }
        });


        $scope.openPopover = function ($event) {
            if (!$scope.showDropdown) return;
            frameworkService.createPopover($scope, 'views/other/headerTitlePopover.html', 'none')
                .then(function (popover) {
                    $scope.popover = popover;
                    $scope.popover.show($event);
                });
        };

        $scope.closePopover = function () {
            $scope.popover.hide();
        };

        $scope.$on('$destroy', function () {
            if ($scope.popover) {
                $scope.popover.remove();
            }
        });
    };

    headerTitleController.$inject = ['$scope', 'frameworkService', 'headerTitleService', 'config_constants'];
    return headerTitleController;
});