define([], function () {
    var leftMenuController = function ($rootScope, $scope, frameworkService, leftMenuService) {
        $scope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {
            var statesWithoutButton = [
                'landing',
                'userActivate',
                'resetPassword',
                'userUpdateUsername'
            ];
            $rootScope.disableMenus = _.every(statesWithoutButton, function (item) {
                return item !== toState.name;
            });
        });

        $scope.menu = leftMenuService.getMenu();

        $scope.toggleGroup = function (key) {
            $scope.shownGroup = $scope.isGroupShown(key) ? null : key;
        };
        $scope.isGroupShown = function (key) {
            return $scope.shownGroup === key;
        };

        $scope.selectItem = function (item) {
            if (item.webUrl) {
                frameworkService.openInBrowser(item.webUrl);
            } else if (_.isEmpty(item.children)) {
                $scope.toggleGroup();
                frameworkService.toggleLeftMenu();
                frameworkService.disableNextAnimation();
                frameworkService.navigateTo(item.state, item.params);
            } else {
                $scope.toggleGroup(item.state);
            }
        };

        $scope.leftMenuAvatarNavigation = function () {
            if ($rootScope.isLoggedIn) {
                frameworkService.navigateToHome();
            } else {
                frameworkService.disableNextAnimation();
                frameworkService.navigateTo('landing');
            }
        };
    };

    leftMenuController.$inject = ['$rootScope', '$scope', 'frameworkService', 'leftMenuService'];
    return leftMenuController;
});
