define([], function () {
    var rightMenuController = function ($scope, $http, $window, frameworkService, config_constants, i18nFilter) {
        $scope.openPopover = function ($event) {
            frameworkService.createPopover($scope, 'views/other/rightMenu.html', 'slide-in-right')
                .then(function (popover) {
                    $scope.popover = popover;
                    $scope.popover.show($event);
                });
        };

        $scope.closePopover = function () {
            $scope.popover.hide();
        };

        $scope.openLeftMenu = function () {
            frameworkService.toggleLeftMenu();
        };

        var message = i18nFilter('Share app message');
        var subject = i18nFilter('Share app subject');
        var url = config_constants.shareUrl;
        $scope.shareApp = function () {
            try {
                frameworkService.showLoading();
                $window.plugins.socialsharing.share(message, subject, null, url, function () {
                    frameworkService.hideLoading();
                    // Share callback doesn't provide information
                });
            } catch (err) {
                frameworkService.hideLoading();
                frameworkService.showAlert('This feature is available only in the app.');
            }
        };

        $scope.$on('$destroy', function () {
            if ($scope.popover) {
                $scope.popover.remove();
            }
        });
    };

    rightMenuController.$inject = ['$scope', '$http', '$window', 'frameworkService', 'config_constants', 'i18nFilter'];
    return rightMenuController;
});