define([], function () {
    var settingsController = function ($scope, fencingService, frameworkService, notificationService, country_options) {
        $scope.countries = country_options;

        $scope.selectCountry = function (country) {
            fencingService.setCountry(country);
            $scope.settings.country = country;
        };

        $scope.openCountryModal = function () {
            frameworkService.showModal($scope, 'views/other/countriesModal.html');
        };

        $scope.settings = {
            country: fencingService.getCountry(),
            advert_notifications: notificationService.getAdvertNotificationsState()
        };

        $scope.save = function () {
            notificationService.setAdvertNotificationsState($scope.settings.advert_notifications);
            frameworkService.showToast('Settings saved');
        };
    };

    settingsController.$inject = ['$scope', 'fencingService', 'frameworkService', 'notificationService', 'country_options'];
    return settingsController;
});