define([], function() {
    var paymentDetailController = function($scope, paymentResponse) {
        var _parsePayment = function(payment) {
            var in_app_payment = _.chain(payment.action_history).find({ action: 'paid_in_app' }).get('details').value();
            if (in_app_payment)
                in_app_payment = _.zipObject(_.map(in_app_payment, 'key'), _.map(in_app_payment, 'value'));

            var in_store_payment = _.chain(payment.action_history).find({ action: 'paid_in_store' }).get('details').value();
            if (in_store_payment)
                in_store_payment = _.zipObject(_.map(in_store_payment, 'key'), _.map(in_store_payment, 'value'));

            payment.in_app_payment_details = in_app_payment;
            payment.in_store_payment_details = in_store_payment;

            payment.loyalty_earned = _.chain(payment.action_history).find({ action: 'loyalty_earn_captured' }).get('details').find({ key: 'amount' }).get('value').defaultTo(0).toNumber().value();
            payment.loyalty_spent = Math.abs(_.chain(payment.action_history).find({ action: 'loyalty_spend_captured' }).get('details').find({ key: 'amount' }).get('value').defaultTo(0).toNumber().value());
        };
        _parsePayment(paymentResponse.data);

        $scope.payment = paymentResponse.data;
        $scope.location = $scope.payment.location_snapshot;
        $scope.merchant = $scope.payment.merchant_snapshot;
    };

    paymentDetailController.$inject = ['$scope', 'paymentResponse'];
    return paymentDetailController;
});
