define([], function () {
    var paymentMethodAddController = function ($scope, frameworkService, paymentService, response_enum) {
        var stripe_form = paymentService.createStripeForm('#stripe-form');

        $scope.getToken = function () {
            paymentService.createStripeToken(stripe_form)
                .then(function (result) {
                    if (result.error) {
                        frameworkService.showAlert(result.error.message);
                    } else {
                        paymentService.addPaymentMethod(result.token.id)
                            .then(function (response) {
                                if (response.response_code == response_enum.CODE.SUCCESS) {
                                    frameworkService.showToast('Payment method added');
                                    frameworkService.navigateTo('profile');
                                } else {
                                    frameworkService.showAlert(_.head(response.data).message);
                                }
                            });
                    }
                });
        };
    };

    paymentMethodAddController.$inject = ['$scope', 'frameworkService', 'paymentService', 'response_enum'];
    return paymentMethodAddController;
});