define([], function () {
    var reviewLocationListController = function ($scope, $filter, locationsResponse, reviewService, reviewUtilService, frameworkService, response_enum) {
        if (!_.isEmpty(reviewUtilService.getReview())) reviewUtilService.clearReview();

        $scope.locations = _.map(locationsResponse.data, function (location) {
            // Extend locations with the full name of state and country so that it is filterable
            return _.merge(location, {
                address: {
                    state_long: $filter('bindName')(location.address.state, 'state_options'),
                    country_long: $filter('bindName')(location.address.country, 'country_options'),
                }
            });
        });

        $scope.getReviewByLocation = function (id) {
            reviewService.getFields(id).then(function (response) {
                if (response.response_code === response_enum.CODE.SUCCESS) {
                    reviewUtilService.setGoReviewFields(response.data);
                    frameworkService.navigateTo('goReviewUser');
                } else {
                    frameworkService.showError(response.data);
                }
            });
        };
    };

    reviewLocationListController.$inject = ['$scope', '$filter', 'locationsResponse', 'reviewService', 'reviewUtilService', 'frameworkService', 'response_enum'];
    return reviewLocationListController;
});
