define([], function () {
    var activityController = function ($scope, activitiesFetcher, frameworkService, response_enum) {
        $scope.moreDataCanBeLoaded = true;
        $scope.activities = [];

        $scope.loadMoreData = function () {
            frameworkService.loadMoreData($scope, activitiesFetcher)
                .then(function (response) {
                    if (response != null) {
                        if (response.response_code === response_enum.CODE.SUCCESS) {
                            $scope.activities = $scope.activities.concat(response.data);
                        } else {
                            frameworkService.showError(response.data);
                        }
                    } else {
                        $scope.moreDataCanBeLoaded = false;
                    }
                });
        };

        $scope.navigateToDetails = function (activity) {
            frameworkService.navigateTo(activity.source_type + 'Detail', { _id: activity.source_id });
        };
    };

    activityController.$inject = ['$scope', 'activitiesFetcher', 'frameworkService', 'response_enum'];
    return activityController;
});
