define([], function () {
    var addressEditController = function ($scope, addressService, frameworkService, country_options, state_options, addressResponse, config_constants, response_enum) {
        $scope.countries = country_options;
        $scope.states = state_options;

        if (addressResponse) {
            $scope.address = addressResponse.data;
        } else {
            $scope.address = {
                country: config_constants.country
            };
        }

        $scope.delete = function () {
            addressService.deleteAddress($scope.address._id)
                .then(function (response) {
                    if (response.response_code == response_enum.CODE.SUCCESS) {
                        frameworkService.showToast('Address deleted');
                        frameworkService.navigateTo('profile');
                    } else {
                        frameworkService.showError(response.data);
                    }
                });
        };

        $scope.save = function () {
            var data = angular.copy($scope.address);

            addressService.saveAddress(data)
                .then(function (response) {
                    if (response.response_code == response_enum.CODE.SUCCESS) {
                        frameworkService.showToast('Address added');
                        frameworkService.navigateTo('profile');
                    } else {
                        frameworkService.showError(response.data);
                    }
                });
        };
    };

    addressEditController.$inject = ['$scope', 'addressService', 'frameworkService', 'country_options', 'state_options', 'addressResponse', 'config_constants', 'response_enum'];
    return addressEditController;
});
