define([], function () {
    var changePasswordController = function ($scope, userService, frameworkService, response_enum) {
        $scope.user = {};

        $scope.changePassword = function () {
            var data = _.pick($scope.user, ['old_password', 'new_password']);
            userService.changePassword(data)
                .then(function (response) {
                    if (response.response_code == response_enum.CODE.SUCCESS) {
                        frameworkService.showToast('Your password has been changed');
                        frameworkService.navigateTo('profile');
                    } else {
                        var msg;
                        if (_.some(response.data, { message: response_enum.ERROR_CODES.AUTH_INVALID_CREDENTIALS })) {
                            msg = 'Current password is incorrect.';
                        } else {
                            msg = _.get(_.head(response.data), 'message'); // Display the error msg even if it's not expected (Clique integration is unpredictable)
                        }
                        if (!_.isEmpty(msg)) {
                            frameworkService.showAlert(msg);
                        } else {
                            frameworkService.showError(response.data);
                        }
                    }
                });
        };
    };

    changePasswordController.$inject = ['$scope', 'userService', 'frameworkService', 'response_enum'];
    return changePasswordController;
});
