define([], function () {
    var completeRegistrationController = function ($scope, $stateParams, userService, moment, frameworkService, keenService, config_constants, response_enum) {
        $scope.user = {
            mbm_id: $stateParams.mbm_id
        };

        $scope.$watch('user.birthday', function () {
            var birthday = moment($scope.user.birthday, 'DD/MM/YYYY');
            (moment().diff(birthday, 'years') >= 18) ? $scope.age = moment().diff(birthday, 'years') : $scope.age = null;
        });

        $scope.submit = function () {
            if (!$scope.user.tc_checked) {
                frameworkService.showAlert('You need to accept the terms and conditions.');
                return;
            }
            var data = angular.copy($scope.user);
            if (data.birthday) data.birthday = moment.utc(data.birthday, 'DD/MM/YYYY').toISOString();
            data.mobile_country = _.toUpper(data.mobile_country);
            return userService.completeRegistration(data).then(function (response) {
                if (response.response_code === response_enum.CODE.SUCCESS) {
                    keenService.recordEvent('registrations', response.data);
                    var msg = config_constants.username === 'mobile' ?
                        'Thank you for joining.<br>Please check your phone to verify your account before login.' :
                        'Thank you for joining.'; // Facebook registration does not require email verification
                    frameworkService.showAlert(msg).then(function () {
                        frameworkService.navigateTo('facebookUserActivate');
                    });
                } else if (_.some(response.data, { message: response_enum.ERROR_CODES.APPUSER_MOBILE_ALREADY_IN_USE })) {
                    frameworkService.showAlert('This mobile is already in use.');
                } else if (_.some(response.data, { message: response_enum.ERROR_CODES.APPUSER_EMAIL_ALREADY_IN_USE })) {
                    frameworkService.showAlert('This email is already in use.');
                } else if (_.some(response.data, { message: response_enum.ERROR_CODES.MBM_USERNAME_ALREADY_IN_USE })) {
                    frameworkService.showAlert(config_constants.username === 'mobile' ? 'This mobile is already in use.' : 'This email is already in use.');
                } else {
                    frameworkService.showError(response.data);
                }
            });

        };
    };

    completeRegistrationController.$inject = ['$scope', '$stateParams', 'userService', 'moment', 'frameworkService', 'keenService', 'config_constants', 'response_enum'];
    return completeRegistrationController;
});