define([], function () {
    var facebookUserActivateController = function ($scope, userService, frameworkService, response_enum, taggingService) {
        $scope.user = {
            token: null
        };

        $scope.submit = function () {
            return userService.activateFacebookUser($scope.user.token).then(function (response) {
                if (response.response_code === response_enum.CODE.SUCCESS) {
                    taggingService.pushEvent('facebookRegistration', {});

                    frameworkService.showAlert('Success! Your mobile has been validated.').then(function () {
                        frameworkService.navigateToHome({ tokenSuccess: true });
                    });
                } else if (_.some(response.data, { message: response_enum.ERROR_CODES.TOKEN_INVALID })) {
                    frameworkService.showAlert('Invalid token.');
                } else {
                    frameworkService.showError(response.data);
                }
            });
        };
    };

    facebookUserActivateController.$inject = ['$scope', 'userService', 'frameworkService', 'response_enum', 'taggingService'];
    return facebookUserActivateController;
});