define([], function () {
    var forgotPasswordController = function ($scope, $stateParams, frameworkService, userService, response_enum) {
        $scope.user = {
            username: $stateParams.username
        };

        $scope.send = function () {
            userService.sendForgotPassword($scope.user.username).then(function (response) {
                if (response.response_code === response_enum.CODE.SUCCESS) {
                    frameworkService.showAlert('An SMS has been sent to your number with a token to reset your password.')
                        .then(function () {
                            frameworkService.navigateTo('resetPassword');
                        });
                } else {
                    if (_.some(response.data, { message: response_enum.ERROR_CODES.APPUSER_NOT_FOUND })) {
                        frameworkService.showAlert('This mobile is not registered.');
                    } else {
                        frameworkService.showError(response.data);
                    }
                }
            });
        };
    };

    forgotPasswordController.$inject = ['$scope', '$stateParams', 'frameworkService', 'userService', 'response_enum'];
    return forgotPasswordController;
});