define([], function () {
    var loginController = function ($scope, $stateParams, frameworkService, userService, config_constants, response_enum) {
        $scope.user = {
            username: $stateParams.username,
            password: null
        };

        var onLogin = function (response) {
            if (response.response_code === response_enum.CODE.SUCCESS) {
                if (_.isNil(response.data.username)) { // Social sign in flow
                    frameworkService.navigateTo('completeRegistration', { mbm_id: response.data.mbm_id });
                } else {
                    frameworkService.showToast('Welcome back ' + response.data.first_name);
                    if (!$stateParams.redirect_state) {
                        frameworkService.navigateToHome();
                    } else {
                        frameworkService.navigateTo($stateParams.redirect_state, $stateParams.redirect_params);
                    }
                }
            } else {
                if (_.some(response.data, { message: response_enum.ERROR_CODES.APPUSER_STATUS_INACTIVE })) {
                    if (config_constants.username === 'mobile') {
                        frameworkService.showAlert('To confirm you are the owner of this number, please check your phone and enter the token on the next page.').then(function () {
                            frameworkService.navigateTo('userActivate', { username: $scope.user.username });
                        });
                    } else {
                        frameworkService.showAlert('To confirm you are the owner of this email address, please check your account and click on the link to activate it.');
                    }
                } else if (_.some(response.data, { message: response_enum.ERROR_CODES.AUTH_INVALID_CREDENTIALS })) {
                    frameworkService.showAlert('Username and password don\'t match.');
                } else if (_.some(response.data, { message: response_enum.ERROR_CODES.APPUSER_STATUS_DISABLED })) {
                    frameworkService.showAlert('Your account is disabled. If you have any questions, please contact customer support.');
                } else if (_.some(response.data, { message: response_enum.ERROR_CODES.FACEBOOK_EMAIL_REQUIRED })) {
                    frameworkService.showAlert('Please provide your email address.');
                } else if (_.some(response.data, { message: response_enum.ERROR_CODES.APPUSER_EMAIL_ALREADY_IN_USE })) {
                    frameworkService.showAlert('Email is already in use.');
                } else {
                    frameworkService.showError(response.data);
                }
            }
        };

        $scope.login = function () {
            userService.login($scope.user.username, $scope.user.password).then(onLogin);
        };

        $scope.signInWithOAuth = function (provider) {
            userService.signInWithOAuth(provider).then(onLogin);
        };
    };

    loginController.$inject = ['$scope', '$stateParams', 'frameworkService', 'userService', 'config_constants', 'response_enum'];
    return loginController;
});