define([], function () {
    var referFriendController = function ($scope, $window, userResponse, frameworkService, keenService, utilityService, i18nFilter, config_constants) {
        $scope.user = userResponse.data;

        keenService.recordEvent('referrals_view');

        var message = utilityService.stringFormat(i18nFilter('Share referral message'), $scope.user.referral.code);
        var subject = utilityService.stringFormat(i18nFilter('Share referral subject'), $scope.user.referral.code);
        var url = config_constants.shareUrl;
        $scope.share = function () {
            try {
                frameworkService.showLoading();
                $window.plugins.socialsharing.share(message, subject, null, url, function () {
                    frameworkService.hideLoading();
                    // Share callback doesn't provide information
                });
            } catch (err) {
                frameworkService.hideLoading();
                frameworkService.showAlert('This feature is available only in the app.');
            }
        };
    };

    referFriendController.$inject = ['$scope', '$window', 'userResponse', 'frameworkService', 'keenService', 'utilityService', 'i18nFilter', 'config_constants'];
    return referFriendController;
});