define([], function () {
    var resetPasswordController = function ($scope, $stateParams, userService, frameworkService, response_enum) {
        $scope.user = {
            token: $stateParams.token
        };

        $scope.resetPassword = function () {
            userService.resetPassword($scope.user).then(function (response) {
                if (response.response_code === response_enum.CODE.SUCCESS) {
                    frameworkService.showAlert('Success! Your password has been changed.<br>To continue, please login to the app.').then(function () {
                        frameworkService.navigateTo('login');
                    });
                } else if (_.some(response.data, { message: response_enum.ERROR_CODES.TOKEN_INVALID })) {
                    frameworkService.showAlert('Invalid token.');
                } else {
                    frameworkService.showAlert('Your password could not be changed.');
                }
            });
        };
    };

    resetPasswordController.$inject = ['$scope', '$stateParams', 'userService', 'frameworkService', 'response_enum'];
    return resetPasswordController;
});