define([], function () {
    var userUpdateUsernameController = function ($scope, $stateParams, userService, frameworkService, response_enum) {
        $scope.user = {
            token: null
        };

        $scope.submit = function () {
            return userService.updateUsername($scope.user.token).then(function (response) {
                if (response.response_code === response_enum.CODE.SUCCESS) {
                    frameworkService.showAlert('Your mobile has been updated.').then(function () {
                        frameworkService.navigateTo('profile');
                    });
                } else if (_.some(response.data, { message: response_enum.ERROR_CODES.TOKEN_INVALID })) {
                    frameworkService.showAlert('Invalid token.');
                } else {
                    frameworkService.showError(response.data);
                }
            });
        };
    };

    userUpdateUsernameController.$inject = ['$scope', '$stateParams', 'userService', 'frameworkService', 'response_enum'];
    return userUpdateUsernameController;
});
