define([], function () {
    var map = function () {
        return {
            restrict: 'E',
            replace: true,
            scope: {
                address: '<'
            },
            templateUrl: 'directives/templates/addressMap.html',
            link: function ($scope, $element) {
                var watcherAddress = $scope.$watch('address', function () {
                    if (!($scope.address && $scope.address.address1 && $scope.address.suburb && $scope.address.country && $scope.address.state))
                        return;

                    var fullAddress = '';
                    fullAddress += $scope.address.address1 + ', ';
                    fullAddress += $scope.address.address2 ? $scope.address.address2 + ', ' : '';
                    fullAddress += $scope.address.address3 ? $scope.address.address3 + ', ' : '';
                    fullAddress += $scope.address.address4 ? $scope.address.address4 + ', ' : '';
                    fullAddress += $scope.address.suburb + ', ';
                    fullAddress += $scope.address.state + $scope.address.postcode + ', ';
                    fullAddress += $scope.address.country;

                    $scope.marker = fullAddress;
                }, true); // Deep watch on address properties

                // Cleanup for the directive
                $element.on('$destroy', function () {
                    watcherAddress();
                });
            }
        };
    };

    map.$inject = [];
    return map;
});