define([], function () {
    var countdown = function ($interval, moment) {
        return {
            restrict: 'E',
            replace: true,
            scope: {
                seconds: '<',
                callback: '&'
            },
            templateUrl: 'directives/templates/countdown.html',
            link: function ($scope, $element) {
                $scope.secondsString = ('0' + $scope.seconds % 60).slice(-2);
                $scope.minutesString = ('0' + Math.floor($scope.seconds / 60)).slice(-2);

                var start = moment();
                var intervalFn = $interval(function () {
                    var now = moment();
                    var remaining = $scope.seconds - Math.floor(now.diff(start) / 1000);
                    if (remaining >= 0) {
                        $scope.secondsString = ('0' + remaining % 60).slice(-2);
                        $scope.minutesString = ('0' + Math.floor(remaining / 60)).slice(-2);
                    } else {
                        $scope.secondsString = $scope.minutesString = '00';
                        $scope.stopInterval();
                        $scope.callback();
                    }
                }, 1000, false);

                $scope.stopInterval = function () {
                    if (intervalFn) {
                        $interval.cancel(intervalFn);
                        intervalFn = null;
                    }
                };

                $scope.$on('$destroy', function () {
                    $scope.stopInterval(); // Make sure that the interval is destroyed too
                });
            }
        };
    };

    countdown.$inject = ['$interval', 'moment'];
    return countdown;
});
