define([], function() {
    var disableTap = function($interval) {
        return {
            link: function($scope, $element) {
                var watcher = $interval(function() {
                    var containers = document.getElementsByClassName('pac-container'); // Find google places div
                    if (!_.isEmpty(containers)) {
                        $interval.cancel(watcher);
                        watcher = undefined;

                        angular.element(containers).attr('data-tap-disabled', 'true'); // disable ionic data tab
                        angular.element(containers).on('click', function() {
                            $element.blur(); // leave input field if google-address-entry is selected
                        });
                    }
                }, 1000);

                // Cleanup for the directive
                $element.on('$destroy', function() {
                    if (watcher) {
                        $interval.cancel(watcher);
                        watcher = undefined;
                    }
                });
            }
        };
    };

    disableTap.$inject = ['$interval'];
    return disableTap;
});
