define([], function() {
    var equalTo = function() {
        return {
            restrict: 'A',
            require: 'ngModel',
            link: function($scope, $element, attrs, ngModelController) {
                var isValid = function(modelValue) {
                    return modelValue == attrs.equalTo;
                };

                ngModelController.$validators.equalTo = isValid;

                var watcher = attrs.$observe('equalTo', function() {
                    ngModelController.$setValidity('equalTo', isValid(ngModelController.$modelValue));
                });

                // Cleanup for the directive
                $element.on('$destroy', function() {
                    watcher(); // This actually removes the watcher
                });
            }
        };
    };

    equalTo.$inject = [];
    return equalTo;
});
