define([], function() {
    var focusOnError = function($timeout, frameworkService) {
        return {
            restrict: 'A',
            link: function($scope, $element) {
                $element.on('submit', function() {
                    var firstInvalid = $element[0].querySelector('.ng-invalid');
                    if (firstInvalid) {
                        // Sometimes the input are hidden, so they can't be focused on. In those cases, scroll to it
                        if (firstInvalid.tagName === 'DIV') {
                            frameworkService.scrollTop(firstInvalid.getBoundingClientRect().top - 50);
                        } else {
                            $timeout(function() {
                                firstInvalid.focus();
                            });
                        }
                    }
                });
            }
        };
    };

    focusOnError.$inject = ['$timeout', 'frameworkService'];
    return focusOnError;
});
