define([], function () {
    var integerCurrency = function ($locale) {
        var REGEXP = /^\d*$/;

        // When we have a currency whose fractionSize is not 2, we can use this library to check it:
        // https://github.com/xsolla/angular-currency-format and $locale
        return {
            priority: 999, // Priority set to avoid conflict with AngularAgility
            restrict: 'A',
            require: 'ngModel',
            link: function ($scope, $element, attrs, ngModelController) {
                ngModelController.$formatters.push(function (value) {
                    var transformedValue = value ? _.round(value / 100, 2) : value;
                    if (transformedValue != value) {
                        ngModelController.$setViewValue(transformedValue);
                        ngModelController.$render();
                    }
                    return transformedValue;
                });
                ngModelController.$parsers.push(function (value) {
                    return value ? _.round(value * 100) : value;
                });
                ngModelController.$validators.number = function (value) {
                    return value ? REGEXP.test(value) : true;
                };

                // $element.wrap('<div class="input-group"></div>');
                // $element.before('<span class="input-group-addon">' + $locale.NUMBER_FORMATS.CURRENCY_SYM + '</span>');
            }
        };
    };

    integerCurrency.$inject = ['$locale'];
    return integerCurrency;
});
