define([], function () {
    var loginPrompt = function ($rootScope, $timeout, $state, $stateParams, frameworkService, i18nFilter) {
        return {
            restrict: 'A',
            scope: {
                allowGuest: '<',
                message: '@'
            },
            link: function ($scope, $element, attrs) {
                $scope.navigateToLogin = function () {
                    frameworkService.navigateTo('login', {
                        redirect_state: $state.current.name,
                        redirect_params: angular.copy($stateParams)
                    });
                };
                $scope.continueAsGuest = function () {
                    $element.off('click', handler);
                    $timeout(function () {
                        $element[0].click();
                    });
                };

                var handler = function (event) {
                    if ($rootScope.isLoggedIn)
                        return;
                    event.stopPropagation(); // Stop the rest of the events

                    $scope.popup = frameworkService.showPopup({
                        title: i18nFilter('Please login or join to continue'),
                        template: $scope.message,
                        templateUrl: 'directives/templates/loginPrompt.html',
                        scope: $scope
                    });
                };

                $element.on('click', handler);
            }
        };
    };

    loginPrompt.$inject = ['$rootScope', '$timeout', '$state', '$stateParams', 'frameworkService', 'i18nFilter'];
    return loginPrompt;
});
