define([], function () {
    var maximumAge = function (moment) {
        return {
            restrict: 'A',
            require: 'ngModel',
            link: function ($scope, $element, attrs, ngModelController) {
                var isValid = function (modelValue) {
                    if (!modelValue || !attrs.maximumAge) {
                        return true;
                    } else {
                        var date1 = moment(modelValue, 'DD/MM/YYYY');
                        var date2 = moment().subtract(attrs.maximumAge, 'years');
                        return moment(date1).isSameOrAfter(date2);
                    }
                };

                ngModelController.$validators.maximumAge = isValid;
            }
        };
    };

    maximumAge.$inject = ['moment'];
    return maximumAge;
});
