define([], function () {
    var minimumAge = function (moment) {
        return {
            restrict: 'A',
            require: 'ngModel',
            link: function ($scope, $element, attrs, ngModelController) {
                var isValid = function (modelValue) {
                    if (!modelValue || !attrs.minimumAge) {
                        return true;
                    } else {
                        var date1 = moment(modelValue, 'DD/MM/YYYY');
                        var date2 = moment().subtract(attrs.minimumAge, 'years');
                        return moment(date1).isSameOrBefore(date2);
                    }
                };

                ngModelController.$validators.minimumAge = isValid;
            }
        };
    };

    minimumAge.$inject = ['moment'];
    return minimumAge;
});
