define([], function() {
    var openingHours = function(utilityService) {
        return {
            restrict: 'E',
            replace: true,
            scope: {
                ngModel: '<'
            },
            templateUrl: 'directives/templates/openingHours.html',
            link: function($scope, $element) {
                if ($scope.ngModel) {
                    $scope.todayName = utilityService.getDayName(new Date(), $scope.ngModel.timezone);
                    var openingHours = _.map($scope.ngModel.opening_hours, function(timeInterval) {
                        return {
                            start: utilityService.setTime(new Date(), timeInterval.start, $scope.ngModel.timezone),
                            end: utilityService.setTime(new Date(), timeInterval.end, $scope.ngModel.timezone),
                            day: timeInterval.day
                        };
                    });
                    $scope.groupedTimeIntervals = utilityService.groupTimeIntervalsByDay(openingHours);
                }
            }
        };
    };

    openingHours.$inject = ['utilityService'];
    return openingHours;
});
