define([], function () {
    var passwordPolicy = function ($templateRequest, $compile, i18nFilter, frameworkService) {
        return {
            restrict: 'A',
            require: 'ngModel',
            link: function ($scope, $element, attrs, ngModelController) {
                $scope.policy = [{
                    description: i18nFilter('At least 1 alphabetical character'),
                    condition: function (value) { return /[a-zA-Z]/.test(value); },
                    isValid: false
                }, {
                    description: i18nFilter('At least 1 numeric character'),
                    condition: function (value) { return /[0-9]/.test(value); },
                    isValid: false
                }
                ];

                var isValid = function (modelValue) {
                    if (!modelValue) {
                        return true;
                    } else {
                        _.forEach($scope.policy, function (item) {
                            item.isValid = item.condition(modelValue);
                        });
                        return _.every($scope.policy, function (item) {
                            return item.isValid;
                        });
                    }
                };
                ngModelController.$validators.passwordPolicy = isValid;

                // due to ion-input wrapper around input for mobile, it is adding the template inside the input box
                // only going to show for desktop for now
                if (frameworkService.getPlatform() === 'web') {
                    $templateRequest('/directives/templates/passwordPolicy.html')
                        .then(function (html) {
                            $element.after($compile(html)($scope));
                        });
                }
            }
        };
    };

    passwordPolicy.$inject = ['$templateRequest', '$compile', 'i18nFilter', 'frameworkService'];
    return passwordPolicy;
});
