define([], function () {
    var passwordPrompt = function ($rootScope, frameworkService, userService, response_enum, i18nFilter) {
        return {
            restrict: 'A',
            link: function ($scope, $element, attrs) {
                $element.on('click', function (event) {
                    event.preventDefault();
                    event.stopPropagation();
                    $scope.user = {
                        username: $rootScope.loggedInUser.username
                    };
                    $scope.popup = frameworkService.showPopup({
                        templateUrl: 'directives/templates/passwordPrompt.html',
                        title: i18nFilter('Login password required'),
                        scope: $scope,
                        buttons: [{
                            text: i18nFilter('Cancel'),
                            type: 'button-assertive'
                        }, {
                            text: i18nFilter('OK'),
                            type: 'button-balanced',
                            onTap: function ($event) {
                                if (!$scope.user.password) {
                                    if ($event) $event.preventDefault();
                                    return;
                                }
                                userService.login($scope.user.username, $scope.user.password)
                                    .then(function (response) {
                                        if (response.response_code === response_enum.CODE.SUCCESS) {
                                            $scope.$eval(attrs.callback);
                                        } else {
                                            if (_.some(response.data, { message: response_enum.ERROR_CODES.AUTH_INVALID_CREDENTIALS })) {
                                                frameworkService.showAlert('Incorrect password.');
                                            } else {
                                                frameworkService.showError(response.data);
                                            }
                                        }
                                    });
                            }
                        }]
                    });
                });

                $scope.closePopup = function () {
                    if ($scope.popup) {
                        $scope.popup.close();
                    }
                };
            }
        };
    };

    passwordPrompt.$inject = ['$rootScope', 'frameworkService', 'userService', 'response_enum', 'i18nFilter'];
    return passwordPrompt;
});
