define([], function () {
    var share = function ($window, config_constants, frameworkService) {
        return {
            restrict: 'E',
            replace: true,
            scope: {
                subject: '@',
                message: '@',
                image: '@',
                url: '@'
            },
            templateUrl: 'directives/templates/share.html',
            link: function ($scope, $element) {
                $scope.share = function () {
                    try {
                        frameworkService.showLoading();
                        $window.plugins.socialsharing.share($scope.message, $scope.subject, $scope.image, $scope.url || config_constants.shareUrl, function () {
                            frameworkService.hideLoading();
                            // Share callback doesn't provide information
                        });
                    } catch (err) {
                        frameworkService.hideLoading();
                        frameworkService.showAlert('This feature is available only in the app.');
                    }
                };
            }
        };
    };

    share.$inject = ['$window', 'config_constants', 'frameworkService'];
    return share;
});