define([], function () {
    var vouchercode = function ($timeout, frameworkService, vouchercodeService, utilityService, keenService, response_enum) {
        return {
            restrict: 'E',
            replace: true,
            scope: {
                ngModel: '<'
            },
            templateUrl: 'directives/templates/vouchercode.html',
            link: function ($scope, $element) {
                $scope.showCountdown = false;
                $scope.showQRcode = false;
                $scope.showBarcode = false;
                $scope.advert = $scope.ngModel.advertinstance_snapshot.advert;
                $scope.status = $scope.ngModel.status;
                $scope.code = $scope.ngModel.code;

                var barcodeOption = $scope.advert.voucher.barcode_option;
                var qrcode;
                if (barcodeOption == 'qrcode') {
                    $scope.showQRcode = true;
                    $timeout(function () {
                        utilityService.generateQRcode('qr', $scope.code);
                    });
                } else if (barcodeOption == 'barcode') {
                    $scope.showBarcode = true;
                }

                $scope.redeemVouchercode = function () {
                    vouchercodeService.redeemVouchercode($scope.ngModel._id)
                        .then(function (response) {
                            if (response.response_code == response_enum.CODE.SUCCESS) {
                                keenService.recordEvent('vouchers_redeem', response.data);
                                $scope.status = response.data.status;

                                frameworkService.showToast('Coupon redeemed');
                                if ($scope.advert.voucher.count_down > 0) {
                                    $scope.showCountdown = true;
                                }
                            } else {
                                if (_.some(response.data, { message: response_enum.ERROR_CODES.VOUCHER_NOT_REEDEMABLE })) {
                                    frameworkService.showAlert('Sorry, this coupon is not available for redemption at this time. Please check the redeem dates.');
                                } else {
                                    frameworkService.showError(response.data);
                                }
                            }
                        });
                };

                $scope.countdownCallback = function () {
                    frameworkService.doRefresh();
                };
            }
        };
    };

    vouchercode.$inject = ['$timeout', 'frameworkService', 'vouchercodeService', 'utilityService', 'keenService', 'response_enum'];
    return vouchercode;
});
