define([], function () {
    var distance = function ($rootScope, $filter) {
        var deg2rad = function (deg) {
            return deg * (Math.PI / 180);
        };

        var getDistanceInKm = function (lat2, lng2) {
            var geolocation = $rootScope.geolocation;
            if (!geolocation) {
                return null;
            }
            var lat1 = geolocation.latitude,
                lng1 = geolocation.longitude;

            var R = 6371; // Radius of the earth in km
            var dLat = deg2rad(lat2 - lat1);
            var dLon = deg2rad(lng2 - lng1);
            var a =
                Math.sin(dLat / 2) * Math.sin(dLat / 2) +
                Math.cos(deg2rad(lat1)) * Math.cos(deg2rad(lat2)) *
                Math.sin(dLon / 2) * Math.sin(dLon / 2);

            var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
            return R * c; // Distance in km
        };

        return function (input) {
            var distance = getDistanceInKm(input[1], input[0]);

            if (distance < 1) {
                return $filter('number')(distance * 1000, 0) + 'm';
            } else if (distance < 10) {
                return $filter('number')(distance, 1) + 'km';
            } else {
                return $filter('number')(distance, 0) + 'km';
            }
        };
    };

    distance.$inject = ['$rootScope', '$filter'];
    return distance;
});