requirejs.config({
    paths: {
        'angular': 'lib/angular.min',
        'angular-agility': 'lib/angular-agility.min',
        'angular-animate': 'lib/angular-animate.min',
        'angular-credit-cards': 'lib/angular-credit-cards',
        'angular-dynamic-locale': 'lib/tmhDynamicLocale.min',
        'angular-moment': 'lib/angular-moment.min',
        'angular-sanitize': 'lib/angular-sanitize.min',
        'angular-ui-mask': 'lib/mask.min',
        'angular-ui-router': 'lib/angular-ui-router.min',
        'angulartics': 'lib/angulartics.min',
        'bugsnag': 'lib/bugsnag.min',
        'ionic': 'lib/ionic.min',
        'ionic-angular': 'lib/ionic-angular.min',
        'ionic-datepicker': 'lib/ionic-datepicker.bundle.min',
        'intlpnIonic': 'lib/intlpnIonic',
        'intlpnIonic-data': 'lib/data',
        'intlpnIonic-utils': 'lib/utils',
        'keen': 'lib/keen-tracking.min',
        'lodash': 'lib/lodash.min',
        'moment': 'lib/moment.min',
        'moment-timezone': 'lib/moment-timezone-with-data.min',
        'ng-map': 'lib/ng-map.min',
        'overlappingmarkerspiderfier': 'https://cdnjs.cloudflare.com/ajax/libs/OverlappingMarkerSpiderfier/1.0.3/oms.min',
        'qrcode': 'lib/qrcode.min',
        'satellizer': 'lib/satellizer.min',
        'stripe': 'https://js.stripe.com/v3/?1',
        'ionic-ratings': 'lib/ionic-ratings.min'
    },
    shim: {
        'angular': {
            exports: 'angular'
        },
        'angular-agility': ['angular'],
        'angular-animate': ['angular'],
        'angular-credit-cards': ['angular'],
        'angular-dynamic-locale': ['angular'],
        'angular-moment': ['angular', 'moment', 'moment-timezone'],
        'angular-sanitize': ['angular'],
        'angular-ui-mask': ['angular'],
        'angular-ui-router': ['angular'],
        'angulartics': ['angular'],
        'bugsnag': [],
        'ionic': [],
        'ionic-angular': ['ionic', 'angular'],
        'ionic-datepicker': ['ionic-angular'],
        'intlpnIonic': ['ionic-angular', 'intlpnIonic-data', 'intlpnIonic-utils'],
        'keen': [],
        'lodash': [],
        'moment': [],
        'moment-timezone': ['moment'],
        'ng-map': ['angular'],
        'overlappingmarkerspiderfier': ['ng-map'],
        'qrcode': [],
        'satellizer': ['angular'],
        'stripe': [],
        'ionic-ratings': ['angular']
    },
    waitSeconds: 0 // Remove timeout
});

require([
    'lodash',
    'app',
    'components',
    'components.theme',
    'components.clique_mbmauth',
    'components.goreview',
    'components.onescan',
    'components.appsflyer'
], function (
    _,
    app,
    components,
    componentsTheme,
    componentsClique_Mbmauth,
    componentsGoReview,
    componentsOneScan,
    componentsAppsFlyer
) {

    function initSdk() {
        var options = {
            // devKey: 'RfPFU6ie8NAtTpjbFD7RnJ', // staging key
            devKey: 'TWoMxCRFmRqSheox2VeLL9', // ---------> production key
            isDebug: true, // (optional, default - false)
            onInstallConversionDataListener: true
        };

        if (ionic.Platform.isIOS()) {
            // options.appId = '030041983'; // staging key
            options.appId = '942895216'; // ---------> production key
        }

        if (ionic.Platform.isAndroid() || (options.appId !== null)) {
            if (window.cordova) {
                window.plugins.appsFlyer.initSdk(options,
                    function successCB(_response) {
                        // console.log(_response);
                    },
                    function errorCB(_error) {
                        // console.log('error', _error);
                    }
                );
            }
        }
    }

    ionic.Platform.ready(function () {
        angular.bootstrap(document, [app.name], {
            strictDi: true
        });
        if (window.plugins && window.plugins.appsFlyer) {
            initSdk();
        }
    });
}
);
