define([], function () {
    var advertResolver = function (utilityService, advertService, favouriteService) {
        this.getAdvertById = function (_id) {
            return utilityService.processResponse(_.partial(advertService.getAdvertById, _id));
        };

        this.getClosestAdvertById = function (_id) {
            return utilityService.processResponse(_.partial(advertService.getClosestAdvertInstanceById, _id));
        };

        this.getAdvertsFetcher = function () {
            return utilityService.createFetcher(10, advertService.getAdverts);
        };

        this.getAdvertsByLocationFetcher = function (_id) {
            return utilityService.createFetcher(10, function (page_size, page_number) {
                return advertService.getAdvertsByLocation(_id, page_size, page_number);
            });
        };

        this.getAdvertsByCategoryFetcher = function (_id) {
            return utilityService.createFetcher(10, function (page_size, page_number) {
                return advertService.getAdvertsByCategory(_id, page_size, page_number);
            });
        };

        this.getAdvertsByExcludingCategoryFetcher = function (_id) {
            return utilityService.createFetcher(10, function (page_size, page_number) {
                return advertService.getAdvertsByExcludingCategory(_id, page_size, page_number);
            });
        };

        this.getFavouritesAdvertsFetcher = function () {
            var favourites = favouriteService.getFavourites();
            var _ids = _.map(_.filter(favourites, { type: 'advert' }), 'document_id');
            if (_.isEmpty(_ids)) {
                return utilityService.createEmptyFetcher();
            }
            return utilityService.createFetcher(10, function (page_size, page_number) {
                return advertService.getAdvertsByIds(_ids, page_size, page_number);
            });
        };
    };

    advertResolver.$inject = ['utilityService', 'advertService', 'favouriteService'];
    return advertResolver;
});