define([], function() {
    var categoryResolver = function(utilityService, categoryService, favouriteService) {

        this.getCategoriesFetcher = function(_id) {
            return utilityService.createFetcher(10, function(page_size, page_number) {
                return categoryService.getCategories(_id, page_size, page_number);
            });
        };

        this.getFavouritesCategoriesFetcher = function() {
            var favourites = favouriteService.getFavourites();
            var _ids = [];
            _.forEach(favourites, function(favourite) {
                if (favourite.type == 'category') {
                    _ids.push(favourite.document_id);
                }
            });
            if (_.isEmpty(_ids)) {
                return utilityService.createEmptyFetcher();
            }
            return utilityService.createFetcher(10, function(page_size, page_number) {
                return categoryService.getCategoriesByIds(_ids, page_size, page_number);
            });
        };

        this.getCategoryById = function(_id) {
            return utilityService.processResponse(_.partial(categoryService.getCategoryById, _id));
        };

    };

    categoryResolver.$inject = ['utilityService', 'categoryService', 'favouriteService'];
    return categoryResolver;
});