define([], function () {
    var locationResolver = function (utilityService, locationService, favouriteService, reviewService) {
        this.getLocationById = function (_id) {
            return locationService.getLocationById(_id);
        };

        this.getLocations = function () {
            return locationService.getLocations();
        };

        this.getGoReviewLocations = function () {
            return reviewService.getStores();
        };

        this.getLocationsByMerchant = function (merchant_id) {
            return locationService.getLocationsByMerchant(merchant_id);
        };

        this.getLocationsByAdvert = function (advert_id) {
            return locationService.getLocationsByAdvert(advert_id);
        };

        this.getFavouritesLocations = function () {
            var favourites = favouriteService.getFavourites();
            var _ids = [];
            _.forEach(favourites, function (favourite) {
                if (favourite.type === 'location') {
                    _ids.push(favourite.document_id);
                }
            });
            if (_.isEmpty(_ids)) {
                return { data: [] };
            }
            return utilityService.processResponse(_.partial(locationService.getLocationsByIds, _ids));
        };
    };

    locationResolver.$inject = ['utilityService', 'locationService', 'favouriteService', 'reviewService'];
    return locationResolver;
});
