define([], function() {
    var merchantResolver = function(utilityService, merchantService, favouriteService) {

        this.getMerchantById = function(_id) {
            return utilityService.processResponse(_.partial(merchantService.getMerchantById, _id));
        };

        this.getMerchantsFetcher = function() {
            return utilityService.createFetcher(10, merchantService.getMerchants);
        };

        this.getFavouritesMerchantsFetcher = function() {
            var favourites = favouriteService.getFavourites();
            var _ids = [];
            _.forEach(favourites, function(favourite) {
                if (favourite.type == 'merchant') {
                    _ids.push(favourite.document_id);
                }
            });
            if (_.isEmpty(_ids)) {
                return utilityService.createEmptyFetcher();
            }
            return utilityService.createFetcher(10, function(page_size, page_number) {
                return merchantService.getMerchantsByIds(_ids, page_size, page_number);
            });
        };

    };

    merchantResolver.$inject = ['utilityService', 'merchantService', 'favouriteService'];
    return merchantResolver;
});