define([], function () {
    var orderResolver = function (utilityService, orderService, menuService) {
        this.getOrderById = function (_id) {
            return utilityService.processResponse(_.partial(orderService.getOrderById, _id));
        };

        this.getMenuById = function (_id) {
            return utilityService.processResponse(_.partial(menuService.getMenuById, _id));
        };

        this.listMenusByIds = function (_ids, menu_type) {
            return utilityService.processResponse(_.partial(menuService.listMenusByIds, _ids, menu_type));
        };

        this.listMenus = function (menu_type) {
            return utilityService.processResponse(_.partial(menuService.listMenus, menu_type));
        };

        this.getPickupMenus = function (menu_type, latitude, longitude) {
            return utilityService.createFetcher(10, function (page_size, page_number) {
                return menuService.getPickupMenus(menu_type, latitude, longitude, page_size, page_number);
            });
        };

        this.getDeliveryMenus = function (menu_type, latitude, longitude, postcode) {
            return utilityService.createFetcher(10, function (page_size, page_number) {
                return menuService.getDeliveryMenus(menu_type, latitude, longitude, postcode, page_size, page_number);
            });
        };
    };

    orderResolver.$inject = ['utilityService', 'orderService', 'menuService'];
    return orderResolver;
});
