define([], function () {
    return {
        CODE: {
            SUCCESS: 0,
            ERROR: 1
        },
        ERROR_CODES: {
            // authentication
            AUTH_INVALID_CREDENTIALS: 'invalid username or password',
            TOKEN_INVALID: 'invalid token',

            // cmsuser
            CMSUSER_NOT_FOUND: 'cms user not found',
            CMSUSER_EMAIL_ALREADY_IN_USE: 'email is already in use',
            CMSUSER_STATUS_INACTIVE: 'cms user status is inactive',
            CMSUSER_STATUS_DELETED: 'cms user status is deleted',
            CMSUSER_ALREADY_ACTIVE: 'cms user status is already active',

            // appuser
            APPUSER_NOT_FOUND: 'app user not found',
            APPUSER_EMAIL_ALREADY_IN_USE: 'app user email is already in use',
            APPUSER_MOBILE_ALREADY_IN_USE: 'app user mobile is already in use',
            APPUSER_STATUS_INACTIVE: 'app user status is inactive',
            APPUSER_STATUS_DISABLED: 'app user status is disabled',
            APPUSER_ALREADY_ACTIVE: 'app user status is already active',
            APPUSER_ALREADY_ACTIVED: 'user already activated',

            //oauth
            OAUTH_ALREADY_LINKED: 'oauth account already linked',

            // facebook
            FACEBOOK_ALREADY_LINKED: 'facebook account already linked',
            FACEBOOK_EMAIL_REQUIRED: 'facebook email is required',

            // role
            ROLE_NOT_FOUND: 'role not found',
            ROLE_ALREADY_EXIST: 'role already exists with this name',
            ROLE_USED_BY_ADVERTS: 'role used by active adverts',
            ROLE_PERMISSION_INVALID: 'one or more of the permissions are invalid',

            // asset
            AMAZON_S3_UPLOAD_FAILED: 'upload to amazon s3 failed',
            ASSET_INVALID_IMG_FORMAT: 'invalid image format',
            ASSET_INVALID_IMG_DIMENSIONS: 'invalid image dimensions',
            ASSET_INVALID_IMG_SIZE: 'invalid image size',
            ASSET_INVALID_IMG_FILE: 'invalid or no image file',
            ASSET_STREAMING_FAILED: 'failed to stream the asset',

            // advert
            ADVERT_NOT_FOUND: 'advert not found',
            ADVERT_WITHOUT_VOUCHER: 'advert does not come with voucher',
            ADVERT_INVALID_APPROVAL_STATUS: 'invalid advert approval status',

            // advert instance
            ADVERT_INSTANCE_NOT_FOUND: 'advert instance not found',

            // favourite
            FAVOURITE_OBJECT_NOT_FOUND: 'favourite object not found',
            FAVOURITE_OBJECT_ALREADY_FAVOURITED: 'favourite object is already favourited',
            FAVOURITE_OBJECT_NOT_FAVOURITED: 'favourite object is not favourited',

            // location
            LOCATION_USED_BY_ADVERTS: 'location used by active adverts',
            LOCATION_NOT_FOUND: 'location not found',

            // merchant
            MERCHANT_NOT_FOUND: 'merchant not found',

            // voucherbatch
            VOUCHERBATCH_NOT_FOUND: 'voucher batch not found',

            // voucher
            VOUCHER_FOR_INVALID_ADVERT_INSTANCE: 'voucher for invalid advert instance',
            VOUCHER_ISSUED_MAX_PER_USER: 'maximum number of vouchers are issued for this user',
            VOUCHER_NOT_ISSUED: 'voucher is not issued',
            VOUCHER_NOT_REEDEMABLE: 'voucher is not redeemable now',
            VOUCHERCODE_NOT_FOUND: 'voucher code not found',

            // email
            EMAIL_TEMPLATE_NOT_FOUND: 'email template not found',

            // ordering
            MENU_NOT_FOUND: 'menu not found',
            ORDER_NOT_FOUND: 'order not found',
            ORDER_PAID: 'order already paid',
            SECTION_NOT_FOUND: 'section not found',
            ITEM_NOT_FOUND: 'item not found',
            VARIANT_NOT_FOUND: 'variant not found',
            VARIANT_PRICE_DIFFERS: 'variant price differs',
            ADDON_NOT_FOUND: 'addon not found',
            ADDON_PRICE_DIFFERS: 'addon price differs',
            TOTAL_CART_DIFFERS: 'total cart differs',
            TOTAL_GROSS_DIFFERS: 'total gross differs',
            TOTAL_NET_DIFFERS: 'total net differs',
            MIN_AMOUNT_NOT_REACHED: 'min amount not reached',
            DELIVERY_FEE_DIFFERS: 'delivery fee differs',
            WEEKEND_SURCHAGE_DIFFERS: 'weekend surcharge differs',
            ORDER_NOT_PAID_YET: 'order has not been paid yet',
            INVALID_COLLECT_TIME: 'invalid collect time',
            LOCATION_ON_HOLIDAYS: 'location is on holidays',
            LOCATION_OFFLINE: 'Sorry, this restaurant is offline, please try again later.',
            LOCATION_CAN_NOT_DELIVER: 'location does not reach delivery address provided',
            LOCATION_ALREADY_HAS_PAYMENT: 'location already has payment',
            LOCATION_DOES_NOT_HAVE_PAYMENT: 'location does not have payment',
            INCORRECT_AMOUNT_FOR_REFUND: 'refund amount is greater than total - refunded',
            ORDER_MULTIPLE_LOCATION: 'multiple location in an order',
            INVALID_PRE_TOTAL_GROSS: 'invalid pre total gross',
            INVALID_PRE_TOTAL_NET: 'invalid pre total net',
            ORDER_REFUND_PERIOD_EXPIRED: 'cannot refund order that expired',

            //stripe
            STRIPE_CUSTOMER_NOT_FOUND: 'user not registered in stripe',
            STRIPE_TOKEN_INVALID: 'invalid stripe token',
            STRIPE_TRANSACTION_FEE_TYPE_INVALID: 'invalid stripe transaction fee type',

            //onescan
            ONESCAN_SAVE_TOKEN_ERROR: 'onescan save token error',
            ONESCAN_ERROR: 'onescan api error',

            //promocode
            PROMOCODE_ALREADY_EXIST: 'promocode already exist',
            PROMOCODE_NOT_FOUND: 'promocode not found',
            PROMOCODE_IS_FOR_REGISTERED_USERS: 'promocode can only be used by registered users',
            PROMOCODE_LIMIT_NOT_MET: 'promocode limit not met',
            PROMOCODE_INCORRECT_MERCHANT: 'promocode invalid merchant',
            PROMOCODE_INVALID_TIME: 'promocode invalid time',
            PROMOCODE_DISCOUNT_DIFFERS: 'promocode discount differs',

            // notification
            NOTIFICATION_TOO_SOON_TO_SEND: 'too soon to send notification',

            // kounta
            CURRENCY_NOT_ALLOWED: 'currency not allowed',
            KOUNTA_MAPPING_NOT_FOUND: 'kounta mapping not found',

            // transaction
            TRANSACTION_NOT_FOUND: 'transaction not found',
            LOCK_USER_FAILED: 'failed to lock user',
            UNLOCK_USER_FAILED: 'failed to unlock user',

            // loyalty
            LOYALY_INSUFFICIENT_BALANCE: 'loyalty insufficient balance',
            LOYALTY_TRANSACTION_NOT_FOUND: 'loyalty transaction not found',
            LOYALTY_RELEASE_CAPTURED: 'loyalty transaction can not be released because it is already captured',

            // geolocation
            INVALID_LATITUDE: 'invalid latitude',
            INVALID_LONGITUDE: 'invalid longitude',

            // clique
            CLIQUE_API_ERROR: 'clique api error',
            CLIQUE_CARD_ALREADY_IN_USE: 'clique card number is already in use',
            CLIQUE_CARD_INVALID: 'clique card is invalid',
            CLIQUE_CARD_NOT_FOUND: 'clique card not found',
            CLIQUE_TRANSACTION_FAILED: 'clique transaction failed',
            CLIQUE_VOUCHER_USED: 'clique voucher is used',
            CLIQUE_VOUCHER_EXPIRED: 'clique voucher is expired',
            CLIQUE_VOUCHER_DECLINED: 'clique voucher was declined',
            CLIQUE_CARD_DISABLED: 'clique card is disabled',
            CLIQUE_INVALID_AGE_RESTRICTION: 'clique invalid age restriction',

            // mbm
            MBM_USERNAME_ALREADY_IN_USE: 'mbm username already in use',

            // exclusivebooks
            FANATICS_MEMBER_NOT_FOUND: 'Invalid member number, surname or first name. Please try again.',
            FANATICS_NUMBER_NOT_FOUND: 'fanatics number not found',

            // respax
            RESPAX_API_ERROR: 'Oops. There appears to be a problem with this booking. Please try again later.',
            RESPAX_TRANSACTION_NOT_PERMITTED: 'Oops. There appears to be a problem with this booking. Please try again later.',

            // goReview
            GOREVIEW_ERROR: 'goreview api error',
            GOREVIEW_ALREADY_SUBMITTED: 'A Review by this customer has already been created in the last 15 minutes.'
        }
    };
});
