define([], function() {
    var advertRoutes = function($stateProvider) {
        $stateProvider
            .state('advertList', {
                url: '/advert/list',
                templateUrl: 'views/advert/list.html',
                controller: 'advertListController',
                resolve: {
                    advertsFetcher: ['advertResolver',
                        function(advertResolver) {
                            return advertResolver.getAdvertsFetcher();
                        }
                    ]
                }
            }).state('advertListByLocation', {
                url: '/advert/bylocation/:_id',
                templateUrl: 'views/advert/list.html',
                controller: 'advertListController',
                resolve: {
                    advertsFetcher: ['$stateParams', 'advertResolver',
                        function($stateParams, advertResolver) {
                            return advertResolver.getAdvertsByLocationFetcher($stateParams._id);
                        }
                    ]
                }
            }).state('advertListByCategory', {
                url: '/advert/bycategory/:_id',
                templateUrl: 'views/advert/list.html',
                controller: 'advertListController',
                resolve: {
                    advertsFetcher: ['$stateParams', 'advertResolver',
                        function($stateParams, advertResolver) {
                            return advertResolver.getAdvertsByCategoryFetcher($stateParams._id);
                        }
                    ]
                }
            }).state('advertListByExcludingCategory', {
                url: '/advert/bycategory/excludes/:_id',
                templateUrl: 'views/advert/list.html',
                controller: 'advertListController',
                resolve: {
                    advertsFetcher: ['$stateParams', 'advertResolver',
                        function($stateParams, advertResolver) {
                            return advertResolver.getAdvertsByExcludingCategoryFetcher($stateParams._id);
                        }
                    ]
                }
            }).state('advertDetail', {
                url: '/advert/detail/:_id',
                cache: false,
                templateUrl: 'views/advert/detail.html',
                controller: 'advertDetailController',
                resolve: {
                    advertResponse: ['$stateParams', 'advertResolver',
                        function($stateParams, advertResolver) {
                            return advertResolver.getAdvertById($stateParams._id);
                        }
                    ]
                }
            }).state('advertDetailClosest', {
                url: '/advert/detail/closest/:_id',
                cache: false,
                templateUrl: 'views/advert/detail.html',
                controller: 'advertDetailController',
                resolve: {
                    advertResponse: ['$stateParams', 'advertResolver',
                        function($stateParams, advertResolver) {
                            return advertResolver.getClosestAdvertById($stateParams._id);
                        }
                    ]
                }
            });

    };

    advertRoutes.$inject = ['$stateProvider'];
    return advertRoutes;
});
