define([], function() {
    var categoryRoutes = function($stateProvider) {
        $stateProvider
            .state('categoryList', {
                url: '/category/list',
                templateUrl: 'views/category/list.html',
                controller: 'categoryListController',
                resolve: {
                    categoriesFetcher: ['categoryResolver',
                        function(categoryResolver) {
                            return categoryResolver.getCategoriesFetcher();
                        }
                    ],
                    parentCategoryResponse: [
                        function() {
                            return null;
                        }
                    ]
                }
            }).state('categoryListById', {
                url: '/subcategory/list/:_id',
                templateUrl: 'views/category/list.html',
                controller: 'categoryListController',
                resolve: {
                    categoriesFetcher: ['$stateParams', 'categoryResolver',
                        function($stateParams, categoryResolver) {
                            return categoryResolver.getCategoriesFetcher($stateParams._id);
                        }
                    ],
                    parentCategoryResponse: ['$stateParams', 'categoryResolver',
                        function($stateParams, categoryResolver) {
                            return categoryResolver.getCategoryById($stateParams._id);
                        }
                    ]
                }
            });
    };

    categoryRoutes.$inject = ['$stateProvider'];
    return categoryRoutes;
});