define([], function () {
    var favouriteRoutes = function ($stateProvider) {
        $stateProvider
            .state('favouriteList', {
                abstract: true,
                cache: false,
                templateUrl: 'views/user/favourites.html'
            }).state('favouriteAdvertList', {
                parent: 'favouriteList',
                url: '/favourite/advert',
                views: {
                    'adverts': {
                        templateUrl: 'views/advert/list.html',
                        controller: 'advertListController',
                        resolve: {
                            advertsFetcher: ['advertResolver',
                                function (advertResolver) {
                                    return advertResolver.getFavouritesAdvertsFetcher();
                                }
                            ]
                        }
                    }
                }
            }).state('favouriteCategoryList', {
                parent: 'favouriteList',
                url: '/favourite/category',
                views: {
                    'categories': {
                        templateUrl: 'views/category/list.html',
                        controller: 'categoryListController',
                        resolve: {
                            categoriesFetcher: ['categoryResolver',
                                function (categoryResolver) {
                                    return categoryResolver.getFavouritesCategoriesFetcher();
                                }
                            ],
                            parentCategoryResponse: [
                                function () {
                                    return null;
                                }
                            ]
                        }
                    }
                }
            }).state('favouriteMerchantList', {
                parent: 'favouriteList',
                url: '/favourite/merchant',
                views: {
                    'merchants': {
                        templateUrl: 'views/merchant/list.html',
                        controller: 'merchantListController',
                        resolve: {
                            merchantsFetcher: ['merchantResolver',
                                function (merchantResolver) {
                                    return merchantResolver.getFavouritesMerchantsFetcher();
                                }
                            ]
                        }
                    }
                }
            }).state('favouriteLocationList', {
                parent: 'favouriteList',
                url: '/favourite/location',
                views: {
                    'locations': {
                        templateUrl: 'views/location/listGroupedByMerchant.html',
                        controller: 'locationListGroupedByMerchantController',
                        resolve: {
                            locationsResponse: ['locationResolver',
                                function (locationResolver) {
                                    return locationResolver.getFavouritesLocations();
                                }
                            ]
                        }
                    }
                }
            });
    };

    favouriteRoutes.$inject = ['$stateProvider'];
    return favouriteRoutes;
});