define([], function () {
    var giftcardRoutes = function ($stateProvider) {
        $stateProvider
            .state('giftcardWelcome', {
                url: '/giftcard/welcome',
                cache: false,
                controller: 'giftcardWelcomeController',
                templateUrl: 'views/giftcard/welcome.html'
            }).state('giftcardCustomer', {
                url: '/giftcard/customer',
                cache: false,
                controller: 'giftcardCustomerController',
                templateUrl: 'views/giftcard/customer.html'
            }).state('giftcardRecipients', {
                url: '/giftcard/recipients',
                cache: false,
                controller: 'giftcardRecipientsController',
                templateUrl: 'views/giftcard/recipients.html'
            }).state('giftcardCheckout', {
                url: '/giftcard/checkout',
                cache: false,
                controller: 'giftcardCheckoutController',
                templateUrl: 'views/giftcard/checkout.html'
            }).state('giftcardConfirmation', {
                url: '/giftcard/confirmation/:status/:reference_id',
                cache: false,
                controller: 'giftcardConfirmationController',
                templateUrl: 'views/giftcard/confirmation.html',
                resolve: {
                    giftcardResponse: ['$stateParams', 'giftcardResolver',
                        function ($stateParams, giftcardResolver) {
                            return giftcardResolver.getGiftcardDetailsById($stateParams.reference_id);
                        }
                    ]
                }
            }).state('giftcardReminder', {
                url: '/giftcard/reminder',
                cache: false,
                controller: 'giftcardReminderController',
                templateUrl: 'views/giftcard/reminder.html'
            }).state('giftcardList', {
                url: '/giftcard/list',
                cache: false,
                controller: 'giftcardListController',
                templateUrl: 'views/giftcard/list.html',
                resolve: {
                    giftcardResponse: ['giftcardResolver',
                        function (giftcardResolver) {
                            return giftcardResolver.getUserGiftcards();
                        }
                    ]
                }
            });
    };

    giftcardRoutes.$inject = ['$stateProvider'];
    return giftcardRoutes;
});
