define([], function () {
    var locationRoutes = function ($stateProvider) {
        $stateProvider
            .state('locationListByMerchant', {
                url: '/location/bymerchant/:_id',
                templateUrl: 'views/location/list.html',
                controller: 'locationListController',
                resolve: {
                    locationsResponse: ['$stateParams', 'locationResolver',
                        function ($stateParams, locationResolver) {
                            return locationResolver.getLocationsByMerchant($stateParams._id);
                        }
                    ]
                }
            }).state('locationListByAdvert', {
                url: '/location/byadvert/:_id',
                templateUrl: 'views/location/list.html',
                controller: 'locationListController',
                resolve: {
                    locationsResponse: ['$stateParams', 'locationResolver',
                        function ($stateParams, locationResolver) {
                            return locationResolver.getLocationsByAdvert($stateParams._id);
                        }
                    ]
                }
            }).state('locationList', {
                url: '/location/list',
                templateUrl: 'views/location/list.html',
                controller: 'locationListController',
                resolve: {
                    locationsResponse: ['locationService',
                        function (locationService) {
                            return locationService.getLocations();
                        }
                    ]
                }
            }).state('locationDetail', {
                url: '/location/detail/:_id',
                templateUrl: 'views/location/detail.html',
                controller: 'locationDetailController',
                resolve: {
                    locationResponse: ['$stateParams', 'locationResolver',
                        function ($stateParams, locationResolver) {
                            return locationResolver.getLocationById($stateParams._id);
                        }
                    ]
                }
            });
    };

    locationRoutes.$inject = ['$stateProvider'];
    return locationRoutes;
});