define([], function () {
    var loyaltyRoutes = function ($stateProvider) {
        $stateProvider
            .state('loyaltyDetail', {
                url: '/loyalty/detail?:tokenSuccess',
                cache: false,
                templateUrl: 'views/loyalty/detail.html',
                controller: 'loyaltyDetailController',
                resolve: {
                    loyaltyResponse: ['loyaltyResolver',
                        function (loyaltyResolver) {
                            return loyaltyResolver.getLoyaltyDetails();
                        }
                    ],
                    userResponse: ['userResolver',
                        function (userResolver) {
                            return userResolver.getCurrentUser();
                        }
                    ]
                }
            }).state('loyaltyVouchers', {
                url: '/loyalty/vouchers',
                cache: false,
                templateUrl: 'views/loyalty/vouchers.html',
                controller: 'loyaltyVouchersController'
            }).state('loyaltyTransactions', {
                url: '/loyalty/transactions',
                cache: false,
                templateUrl: 'views/loyalty/transactions.html',
                controller: 'loyaltyTransactionsController',
                resolve: {
                    loyaltyResponse: ['loyaltyResolver',
                        function (loyaltyResolver) {
                            return loyaltyResolver.getLoyaltyDetails();
                        }
                    ],
                    transactionsResponse: ['loyaltyResolver',
                        function (loyaltyResolver) {
                            return loyaltyResolver.getTransactions();
                        }
                    ]
                }
            }).state('loyaltyBenefits', {
                url: '/loyalty/benefits',
                templateUrl: 'views/loyalty/benefits.html'
            });
    };

    loyaltyRoutes.$inject = ['$stateProvider'];
    return loyaltyRoutes;
});