define([], function () {
    var orderRoutes = function ($stateProvider) {
        $stateProvider
            .state('orderCheckout', {
                url: '/order/checkout/',
                templateUrl: 'views/order/checkout.html',
                controller: 'orderCheckoutController',
                cache: false,
                resolve: {
                    paymentMethodsResponse: ['userService', 'paymentResolver',
                        function (userService, paymentResolver) {
                            if (userService.isAuthenticated()) {
                                return paymentResolver.listPaymentMethods();
                            } else {
                                return null;
                            }
                        }
                    ],
                    addressesResponse: ['userService', 'addressResolver',
                        function (userService, addressResolver) {
                            if (userService.isAuthenticated()) {
                                return addressResolver.listAddresses();
                            } else {
                                return null;
                            }
                        }
                    ]
                }
            }).state('orderConfirmation', {
                url: '/order/confirmation/:status',
                params: { _id: null },
                cache: false,
                controller: 'orderConfirmationController',
                templateUrl: 'views/order/confirmation.html'
            }).state('orderDetail', {
                url: '/order/detail/:_id?:paymentStatus',
                templateUrl: 'views/order/detail.html',
                controller: 'orderDetailController',
                cache: false,
                resolve: {
                    orderResponse: ['$stateParams', 'orderResolver',
                        function ($stateParams, orderResolver) {
                            return orderResolver.getOrderById($stateParams._id);
                        }
                    ]
                }
            });
    };

    orderRoutes.$inject = ['$stateProvider'];
    return orderRoutes;
});
