define([], function() {
    var orderRoutes = function($stateProvider, config_constants) {
        var orderLocationList = {
            url: '/order/:menu_type/location',
            params: { menu_type: 'standard' },
            templateUrl: 'views/order/locationList.html',
            controller: 'orderLocationListController',
            cache: false
        };
        var menuList = {
            url: '/order/:menu_type/menu/:_ids',
            params: { menu_type: 'standard' },
            templateUrl: 'views/order/menuList.html',
            controller: 'menuListController',
            cache: false,
            resolve: {}
        };

        if (config_constants.ordering.flow == 'menus_first') {
            menuList.resolve.menuResponse = ['$stateParams', 'orderResolver',
                function($stateParams, orderResolver) {
                    return orderResolver.listMenus($stateParams.menu_type);
                }
            ];
        } else {
            menuList.resolve.menuResponse = ['$stateParams', 'orderResolver',
                function($stateParams, orderResolver) {
                    return orderResolver.listMenusByIds($stateParams._ids, $stateParams.menu_type);
                }
            ];
        }

        $stateProvider
            .state('orderLocationList', orderLocationList)
            .state('menuList', menuList)
            .state('menuSection', {
                parent: 'menuList',
                url: '/section/:section_id'
            })
            .state('menuItem', {
                parent: 'menuList',
                url: '/item/:item_id'
            });
    };

    orderRoutes.$inject = ['$stateProvider', 'config_constants'];
    return orderRoutes;
});
