define([], function () {
    var otherRoutes = function ($stateProvider, config_constants) {
        $stateProvider
            .state('settings', {
                url: '/settings',
                cache: false,
                templateUrl: 'views/other/settings.html',
                controller: 'settingsController'
            }).state('about', {
                url: '/about',
                templateUrl: 'views/other/about.html'
            }).state('faqs', {
                url: '/faqs',
                templateUrl: 'views/other/faqs.html',
                controller: 'faqsController',
                resolve: {
                    faqsResponse: ['settingsService',
                        function (settingsService) {
                            return settingsService.getFAQs();
                        }
                    ]
                }
            }).state('terms', {
                url: '/terms',
                templateUrl: 'views/other/terms.html',
                controller: 'termsController',
                resolve: {
                    termsResponse: ['settingsService',
                        function (settingsService) {
                            return settingsService.getTerms();
                        }
                    ]
                }
            }).state('privacy', {
                url: '/privacy',
                templateUrl: 'views/other/disclaimers.html',
                controller: 'disclaimersController',
                resolve: {
                    disclaimersResponse: ['settingsService',
                        function (settingsService) {
                            return settingsService.getDisclaimers();
                        }
                    ]
                }
            }).state('disclaimer', {
                url: '/disclaimer',
                templateUrl: 'views/other/disclaimers.html',
                controller: 'disclaimersController',
                resolve: {
                    disclaimersResponse: ['settingsService',
                        function (settingsService) {
                            return settingsService.getDisclaimers();
                        }
                    ]
                }
            }).state('instructions', {
                url: '/instructions',
                templateUrl: 'views/other/instructions.html',
                controller: 'instructionsController',
                resolve: {
                    instructionsResponse: ['settingsService',
                        function (settingsService) {
                            return settingsService.getInstructions();
                        }
                    ]
                }
            });
    };

    otherRoutes.$inject = ['$stateProvider', 'config_constants'];
    return otherRoutes;
});