define([], function () {
    var paymentRoutes = function ($stateProvider) {
        $stateProvider.state('paymentMethodAdd', {
            url: '/user/payment/add',
            templateUrl: 'views/payment/paymentMethodAdd.html',
            controller: 'paymentMethodAddController',
            cache: false
        });
        $stateProvider.state('paymentToken', {
            url: '/user/payment/token',
            templateUrl: 'views/payment/paymentToken.html',
            controller: 'paymentTokenController',
            cache: false,
            resolve: {
                paymentMethodsResponse: ['paymentResolver',
                    function (paymentResolver) {
                        return paymentResolver.listPaymentMethods();
                    }
                ]
            }
        });
        $stateProvider.state('paymentDetail', {
            url: '/user/payment/detail/:_id',
            templateUrl: 'views/payment/detail.html',
            controller: 'paymentDetailController',
            cache: false,
            resolve: {
                paymentResponse: ['$stateParams', 'paymentResolver',
                    function ($stateParams, paymentResolver) {
                        return paymentResolver.getPaymentById($stateParams._id);
                    }
                ]
            }
        });
    };

    paymentRoutes.$inject = ['$stateProvider'];
    return paymentRoutes;
});
