define([], function () {
    var profileRoutes = function ($stateProvider) {
        $stateProvider.state('profile', {
            url: '/user/profile?:tokenSuccess',
            cache: false,
            templateUrl: 'views/user/profile.html',
            controller: 'profileController',
            resolve: {
                userResponse: ['userResolver',
                    function (userResolver) {
                        return userResolver.getCurrentUser();
                    }
                ],
                addressesResponse: ['addressResolver',
                    function (addressResolver) {
                        return addressResolver.listAddresses();
                    }
                ],
                paymentMethodsResponse: ['paymentResolver',
                    function (paymentResolver) {
                        return paymentResolver.listPaymentMethods();
                    }
                ]
            }
        }).state('userEdit', {
            url: '/user/edit/:tab',
            cache: false,
            templateUrl: 'views/user/edit.html',
            controller: 'userEditController',
            resolve: {
                userResponse: ['loyaltyResolver',
                    function (loyaltyResolver) {
                        return loyaltyResolver.getLoyaltyDetails();
                    }
                ],
            }
        }).state('completeRegistration', {
            url: '/user/register/complete/:mbm_id',
            cache: false,
            templateUrl: 'views/user/completeRegistration.html',
            controller: 'completeRegistrationController'
        });
    };

    profileRoutes.$inject = ['$stateProvider'];
    return profileRoutes;
});
