define([], function () {
    var reviewRoutes = function ($stateProvider) {
        $stateProvider
            .state('goReviewWelcome', {
                url: '/goreview/welcome',
                templateUrl: 'views/review/welcome.html'
            }).state('goReviewLocationList', {
                url: '/goreview/location/list',
                templateUrl: 'views/review/locationList.html',
                controller: 'reviewLocationListController',
                resolve: {
                    locationsResponse: ['locationResolver',
                        function (locationResolver) {
                            return locationResolver.getGoReviewLocations();
                        }
                    ]
                }
            }).state('goReviewUser', {
                url: '/goreview/user',
                templateUrl: 'views/review/user.html',
                controller: 'reviewUserController'
            }).state('goReviewRate', {
                url: '/goreview/rate',
                templateUrl: 'views/review/rate.html',
                controller: 'reviewController'
            }).state('goReviewThanks', {
                url: '/goreview/thanks',
                templateUrl: 'views/review/thanks.html',
                controller: 'reviewController',
                params: { reviewResponse: null }
            });
    };

    reviewRoutes.$inject = ['$stateProvider'];
    return reviewRoutes;
});
