define([], function () {
    var userRoutes = function ($stateProvider) {
        var login = {
            url: '/user/login',
            params: {
                redirect_state: null,
                redirect_params: {},
                username: null
            },
            cache: false,
            templateUrl: 'views/user/login.html',
            controller: 'loginController'
        };

        var register = {
            url: '/user/register',
            params: {
                redirect_state: null,
                redirect_params: {}
            },
            cache: false,
            templateUrl: 'views/user/edit.html',
            controller: 'userEditController',
            resolve: {
                userResponse: [
                    function () {
                        return null;
                    }
                ]
            }
        };

        var forgotPassword = {
            url: '/user/forgot/:username',
            cache: false,
            templateUrl: 'views/user/forgotPassword.html',
            controller: 'forgotPasswordController'
        };

        var resetPassword = {
            url: '/user/resetpassword',
            cache: false,
            templateUrl: 'views/user/resetPassword.html',
            controller: 'resetPasswordController'
        };

        var changePassword = {
            url: '/user/changepassword',
            cache: false,
            templateUrl: 'views/user/changePassword.html',
            controller: 'changePasswordController'
        };

        var logout = {
            url: '/user/logout',
            cache: false,
            template: ' ',
            controller: 'logoutController'
        };

        var userActivate = {
            url: '/user/activate/:username',
            cache: false,
            templateUrl: 'views/user/verifyToken.html',
            controller: 'userActivateController'
        };

        var facebookUserActivate = {
            url: '/user/facebook/activate',
            cache: false,
            templateUrl: 'views/user/verifyToken.html',
            controller: 'facebookUserActivateController'
        };

        var userUpdateUsername = {
            url: '/user/username',
            cache: false,
            templateUrl: 'views/user/verifyToken.html',
            controller: 'userUpdateUsernameController'
        };

        var activities = {
            url: '/user/activity',
            cache: false,
            templateUrl: 'views/user/activity.html',
            controller: 'activityController',
            resolve: {
                activitiesFetcher: ['userResolver',
                    function (userResolver) {
                        return userResolver.getActivitiesFetcher();
                    }
                ]
            }
        };

        var landing = angular.copy(login);
        landing.url = '/landing';

        $stateProvider
            .state('login', login)
            .state('register', register)
            .state('forgotPassword', forgotPassword)
            .state('resetPassword', resetPassword)
            .state('changePassword', changePassword)
            .state('logout', logout)
            .state('userActivate', userActivate)
            .state('facebookUserActivate', facebookUserActivate)
            .state('userUpdateUsername', userUpdateUsername)
            .state('activities', activities)
            .state('landing', landing);
    };

    userRoutes.$inject = ['$stateProvider'];
    return userRoutes;
});
