define([], function () {
    var vouchercodeRoutes = function ($stateProvider) {
        $stateProvider
            .state('vouchercodeList', {
                abstract: true,
                cache: false,
                templateUrl: 'views/vouchercode/list.html'
            }).state('vouchercodeIssuedList', {
                parent: 'vouchercodeList',
                url: '/vouchercode/list/issued',
                views: {
                    'issued': {
                        templateUrl: 'views/vouchercode/listContent.html',
                        controller: 'vouchercodeListByUserController',
                        resolve: {
                            vouchercodesResponse: ['vouchercodeResolver',
                                function (vouchercodeResolver) {
                                    return vouchercodeResolver.getVouchercodesByUser('issued');
                                }
                            ]
                        }
                    }
                }
            }).state('vouchercodeRedeemedList', {
                parent: 'vouchercodeList',
                url: '/vouchercode/list/redeemed',
                views: {
                    'redeemed': {
                        templateUrl: 'views/vouchercode/listContent.html',
                        controller: 'vouchercodeListByUserController',
                        resolve: {
                            vouchercodesResponse: ['vouchercodeResolver',
                                function (vouchercodeResolver) {
                                    return vouchercodeResolver.getVouchercodesByUser('redeemed');
                                }
                            ]
                        }
                    }
                }
            }).state('vouchercodeExpiredList', {
                parent: 'vouchercodeList',
                url: '/vouchercode/list/expired',
                views: {
                    'expired': {
                        templateUrl: 'views/vouchercode/listContent.html',
                        controller: 'vouchercodeListByUserController',
                        resolve: {
                            vouchercodesResponse: ['vouchercodeResolver',
                                function (vouchercodeResolver) {
                                    return vouchercodeResolver.getVouchercodesByUser('expired');
                                }
                            ]
                        }
                    }
                }
            }).state('vouchercodeDetail', {
                url: '/vouchercode/detail/:_id',
                templateUrl: 'views/vouchercode/detail.html',
                cache: false,
                controller: 'vouchercodeDetailController',
                resolve: {
                    vouchercodeResponse: ['$stateParams', 'vouchercodeResolver',
                        function ($stateParams, vouchercodeResolver) {
                            return vouchercodeResolver.getVouchercodeById($stateParams._id);
                        }
                    ]
                }
            });
    };

    vouchercodeRoutes.$inject = ['$stateProvider'];
    return vouchercodeRoutes;
});