define([], function () {
    var onRun = function ($rootScope, $state, frameworkService, config_constants) {
        $rootScope.config_constants = config_constants; // To access it in the views
        $rootScope.disableNextAnimation = frameworkService.disableNextAnimation;
        $rootScope.doRefresh = frameworkService.doRefresh;
        $rootScope.openInBrowser = frameworkService.openInBrowser;
        $rootScope.openInModalIFrame = frameworkService.openInModalIFrame;
        $rootScope.goBack = frameworkService.goBack;
        $rootScope.navigateTo = frameworkService.navigateTo;
        $rootScope.navigateToHome = frameworkService.navigateToHome;
        $rootScope.navigateToNewOrder = frameworkService.navigateToNewOrder;

        $rootScope.startsWith = function (actual, expected) {
            return _.startsWith(actual, expected);
        };

        $rootScope.getStateName = function () {
            return $state.current.name;
        };

        $rootScope.validate = function (form, $event) {
            form.$aaFormExtensions.$onSubmitAttempt();
            if (!form.$valid) {
                $event.stopPropagation();
            }
        };

        $rootScope.generateImageUrl = function (path) {
            return path || 'styles/img/default-image.png';
        };

        $rootScope.$on('$stateChangeStart', frameworkService.onStateChangeStart);

        var geolocationWatcher = $rootScope.$on('geolocation:disabled', function (event) {
            geolocationWatcher(); // Unsubscribe this watcher because it should notify only one time
            frameworkService.onGeolocationDisabled();
        });
    };

    onRun.$inject = ['$rootScope', '$state', 'frameworkService', 'config_constants'];
    return onRun;
});
