define([], function () {
    var onRun = function ($rootScope, leftMenuService, config_constants, i18nFilter) {
        leftMenuService.addChild('myAccount', {
            name: i18nFilter('My loyalty'),
            icon: 'fa-heart',
            state: 'loyaltyDetail',
            sort: 2
        });

        leftMenuService.addChild('myAccount', {
            name: i18nFilter('My orders'),
            icon: 'fa-utensils',
            state: 'activities',
            sort: 3,
            hidden: !config_constants.ordering || config_constants.ordering.readonly
        });

        leftMenuService.addChild('myAccount', {
            name: i18nFilter('Add kids'),
            icon: 'fa-smile',
            state: 'kidsBenefits',
            sort: 6,
            hidden: !config_constants.loyalty.kids
        });

        leftMenuService.addButton({
            name: i18nFilter('Gifting'),
            css: 'my-giftcards',
            icon: 'fa-gift',
            state: 'giftcardWelcome',
            sort: 16,
            hidden: !config_constants.loyalty.giftcard
        });

        leftMenuService.addButton({
            name: i18nFilter('Add Kids'),
            icon: 'fa-smile',
            state: 'kidsBenefits',
            sort: 26,
            hidden: !config_constants.loyalty.kids
        });

        leftMenuService.addButton({
            name: i18nFilter('Benefits'),
            icon: 'fa-thumbs-up',
            state: 'loyaltyBenefits',
            sort: 27
        });

        leftMenuService.addButton({
            name: i18nFilter('Instructions'),
            icon: 'fa-clipboard-list',
            state: 'instructions',
            sort: 29
        });

        $rootScope.$watch('isLoggedIn', function () {
            leftMenuService.setButtonVisibility('loyaltyBenefits', !$rootScope.isLoggedIn);
            leftMenuService.setButtonVisibility('instructions', !$rootScope.isLoggedIn);
        });
    };

    onRun.$inject = ['$rootScope', 'leftMenuService', 'config_constants', 'i18nFilter'];
    return onRun;
});
