define([], function () {
    var addressService = function (restService) {
        this.getAddress = function (_id) {
            var apiUrl = '/user/address/delivery/detail/' + _id;
            return restService.get(apiUrl);
        };

        this.listAddresses = function () {
            var apiUrl = '/user/address/delivery/all';
            return restService.get(apiUrl);
        };

        this.saveAddress = function (address) {
            var apiUrl = '/user/address/delivery';
            if (!address._id)
                return restService.post(apiUrl, address);
            else {
                return restService.put(apiUrl, address);
            }
        };

        this.deleteAddress = function (_id) {
            var apiUrl = '/user/address/delivery/' + _id;
            return restService.delete(apiUrl);
        };
    };

    addressService.$inject = ['restService'];
    return addressService;
});
