define([], function () {
    var advertService = function (restService, fencingService) {
        var getGeoUrlParams = function () {
            var sortingCriteria, radius, sortingMode;
            sortingCriteria = fencingService.getSortingCriteria();
            radius = fencingService.getRadius() * 1000;

            switch (sortingCriteria) {
                case 'distance':
                    sortingMode = 'asc';
                    break;
                case 'date_modified':
                    sortingMode = 'desc';
                    break;
                case 'end_date':
                    sortingMode = 'asc';
                    break;
            }
            return radius + '/' + sortingCriteria + '/' + sortingMode;
        };

        this.getAdvertById = function (_id) {
            var apiUrl = '/advert/detail/' + _id;
            return restService.get(apiUrl);
        };

        this.getClosestAdvertInstanceById = function (_id) {
            var apiUrl = '/advert/detail/closest/' + fencingService.getCountry() + '/' + _id;
            return restService.get(apiUrl);
        };

        this.getAdverts = function (page_size, page_number) {
            var apiUrl = '/advert/bygeo/' + fencingService.getCountry() + '/' + getGeoUrlParams() + '/' + page_size + '/' + page_number;
            return restService.get(apiUrl);
        };

        this.getAdvertsByLocation = function (location_id, page_size, page_number) {
            var apiUrl = '/advert/bylocation/' + fencingService.getCountry() + '/' + getGeoUrlParams() + '/' + location_id + '/' + page_size + '/' + page_number;
            return restService.get(apiUrl);
        };

        this.getAdvertsByCategory = function (category_id, page_size, page_number) {
            var apiUrl = '/advert/bycategory/' + fencingService.getCountry() + '/' + getGeoUrlParams() + '/' + category_id + '/' + page_size + '/' + page_number;
            return restService.get(apiUrl);
        };

        this.getAdvertsByExcludingCategory = function (category_id, page_size, page_number) {
            var apiUrl = '/advert/bycategory/' + fencingService.getCountry() + '/' + getGeoUrlParams() + '/true/' + category_id + '/' + page_size + '/' + page_number;
            return restService.get(apiUrl);
        };

        this.getAdvertsByIds = function (_ids, page_size, page_number) {
            var apiUrl = '/advert/byids/' + fencingService.getCountry() + '/' + getGeoUrlParams() + '/' + _ids.join(',') + '/' + page_size + '/' + page_number;
            return restService.get(apiUrl);
        };
    };

    advertService.$inject = ['restService', 'fencingService'];
    return advertService;
});