define([], function () {
    var fencingService = function ($rootScope, $http, config_constants, sorting_options, country_options, tmhDynamicLocale, localStorageService) {
        this.getRadius = function () {
            var radius = localStorageService.retrieve('radius');
            if (_.isNil(radius)) {
                radius = config_constants.geolocation.advertDefaultRadius;
                localStorageService.store('radius', radius);
            }
            return radius;
        };

        this.setRadius = function (value) {
            if (value !== this.getRadius()) {
                localStorageService.store('radius', value);
                $rootScope.$emit('radius:changed', value);
            }
        };

        this.getCountry = function () {
            var country = localStorageService.retrieve('country');
            if (_.isNil(country)) {
                country = config_constants.country;
                this.setCountry(country);
            }
            return country;
        };

        this.setCountry = function (value) {
            localStorageService.store('country', value);
            tmhDynamicLocale.set(this.getLocale());
        };

        this.getCountryName = function () {
            return _.find(country_options, { _id: this.getCountry() }).name;
        };

        this.getLocale = function () {
            return _.find(country_options, { _id: this.getCountry() }).locale;
        };

        this.guessCountry = function () {
            return $http({ url: 'https://freegeoip.net/json/', headers: [] }).then(function (response) {
                return response.data;
            });
        };

        this.getSortingCriteria = function () {
            var sort = localStorageService.retrieve('sorting');
            if (_.isNil(sort)) {
                sort = _.head(sorting_options)._id;
                localStorageService.store('sorting', sort);
            }
            return sort;
        };

        this.setSortingCriteria = function (value) {
            if (value !== this.getSortingCriteria()) {
                localStorageService.store('sorting', value);
                $rootScope.$emit('sorting:changed', value);
            }
        };
    };

    fencingService.$inject = ['$rootScope', '$http', 'config_constants', 'sorting_options', 'country_options', 'tmhDynamicLocale', 'localStorageService'];
    return fencingService;
});
