define([], function () {
    var geolocationService = function ($rootScope, $window, localStorageService, notificationService, restService, userService, config_constants) {
        $rootScope.geolocation = localStorageService.retrieve('geolocation');
        $rootScope.geolocationEnabled = true;

        this.getCurrentGeolocation = function () {
            var onSuccess = function (position) {
                var geolocation = {
                    latitude: position.coords.latitude,
                    longitude: position.coords.longitude
                };
                $rootScope.geolocation = geolocation;
                $rootScope.geolocationEnabled = true;
                localStorageService.store('geolocation', geolocation);
            };
            var onFailure = function (err) {
                $rootScope.geolocation = localStorageService.retrieve('geolocation');
                $rootScope.geolocationEnabled = false;
                if (err && err.code === 1) { // err.code === err.PERMISSION_DENIED
                    $rootScope.$emit('geolocation:disabled');
                }
            };
            var config = {
                enableHighAccuracy: true,
                maximumAge: 1000 * 60, // 1 minute
                timeout: 15000 // 15 seconds
            };
            navigator.geolocation.getCurrentPosition(onSuccess, onFailure, config);
        };
    };
    geolocationService.$inject = ['$rootScope', '$window', 'localStorageService', 'notificationService', 'restService', 'userService', 'config_constants'];
    return geolocationService;
});
