define([], function () {
    var giftcardService = function (restService) {
        this.purchase = function (data) {
            var apiUrl = '/external/clique/giftcard/payment/authorisation';
            return restService.post(apiUrl, data);
        };

        this.setReminder = function (reminder) {
            var apiUrl = '/external/clique/giftcard/reminder';
            return restService.post(apiUrl, reminder);
        };

        this.getGiftcardDetailsById = function (payment_reference) {
            var apiUrl = '/external/clique/giftcard/details/' + payment_reference;
            return restService.get(apiUrl);
        };

        this.getUserGiftcards = function () {
            var apiUrl = '/external/clique/giftcard/transactions';
            return restService.get(apiUrl);
        };

        this.getUserGiftcardsBalance = function (ids) {
            var apiUrl = '/external/clique/giftcard/balances';
            return restService.post(apiUrl, ids);
        };

        this.getAllGiftcardAmounts = function () {
            var apiUrl = '/giftcard/amounts';
            return restService.get(apiUrl);
        };

        this.getPromocodecampaign = function (code, merchant_id) {
            var apiUrl = '/promocodecampaign/' + code + '/' + merchant_id;
            return restService.get(apiUrl);
        };
    };

    giftcardService.$inject = ['restService'];
    return giftcardService;
});
