define(['keen'], function (keen) {
    var keenService = function ($rootScope, config_constants) {
        // TODO: Remove when keen.io is configured in every whitelabel
        if (_.isEmpty(config_constants.keen)) {
            this.recordEvent = function () { };
            return;
        }

        var client = new keen.KeenTracking({
            projectId: config_constants.keen.projectId,
            writeKey: config_constants.keen.writeKey,
            requestType: 'xhr'
        });

        this.recordEvent = function (name, data) {
            if ($rootScope.isLoggedIn) {
                data = data || {};
                data.user = $rootScope.loggedInUser;
            }
            var event = {
                user_agent: '${keen.user_agent}',
                ip_address: '${keen.ip}',
                keen: {
                    addons: [
                        {
                            name: 'keen:ua_parser',
                            input: {
                                ua_string: 'user_agent'
                            },
                            output: 'parsed_user_agent'
                        }, {
                            name: 'keen:ip_to_geo',
                            input: {
                                ip: 'ip_address'
                            },
                            output: 'ip_geo_info'
                        },
                        {
                            name: 'keen:date_time_parser',
                            input: {
                                date_time: 'keen.timestamp'
                            },
                            output: 'timestamp_info'
                        }
                    ]
                },
                data: data
            };
            client.recordEvent(name, event);
        };
    };
    keenService.$inject = ['$rootScope', 'config_constants'];
    return keenService;
});