define([], function () {
    var localStorageService = function ($window) {
        this.store = function (key, value) {
            try {
                $window.localStorage.setItem(key, angular.toJson(value));
            } catch (err) {
                // To avoid circular dependency, use alert instead of frameworkService
                alert('Your web browser does not support storing settings locally. Please try with another browser.');
            }
        };

        this.retrieve = function (key) {
            var value = $window.localStorage.getItem(key);
            if (value === undefined || value === null || value === 'undefined') {
                return null;
            }
            return angular.fromJson(value);
        };

        this.remove = function (key) {
            $window.localStorage.removeItem(key);
        };
    };

    localStorageService.$inject = ['$window'];
    return localStorageService;
});