define([], function () {
    var locationService = function (fencingService, restService) {
        this.getLocationById = function (_id) {
            var apiUrl = '/location/' + _id;
            return restService.get(apiUrl);
        };

        this.getLocations = function () {
            var apiUrl = '/location/all/summary/' + fencingService.getCountry();
            return restService.get(apiUrl);
        };

        this.getLocationsByIds = function (_ids) {
            var apiUrl = '/location/byids/' + fencingService.getCountry() + '/' + _ids.join(',');
            return restService.get(apiUrl);
        };

        this.getLocationsByMerchant = function (merchant_id) {
            var url = '/location/bymerchant/' + fencingService.getCountry() + '/' + merchant_id;
            return restService.get(url);
        };

        this.getLocationsByAdvert = function (advert_id) {
            var apiUrl = '/location/byadvert/' + fencingService.getCountry() + '/' + advert_id;
            return restService.get(apiUrl);
        };

        this.validateCateringPassword = function (data) {
            var apiUrl = '/location/catering/auth';
            return restService.post(apiUrl, data);
        };

        this.getLocationDetailsById = function (id) {
            var apiUrl = '/location/details/' + id;
            return restService.get(apiUrl);
        };
    };

    locationService.$inject = ['fencingService', 'restService'];
    return locationService;
});