define([], function () {
    var menuService = function (fencingService, restService, utilityService) {
        this.getMenuById = function (_id) {
            var apiUrl = '/menu/' + _id;
            return restService.get(apiUrl);
        };

        this.getPickupMenus = function (menu_type, latitude, longitude, page_size, page_number) {
            var apiUrl = utilityService.stringFormat('/menu/pickup/{0}/{1}/{2}/{3}/{4}/{5}', fencingService.getCountry(), menu_type, latitude, longitude, page_size, page_number);
            return restService.get(apiUrl);
        };

        this.getDeliveryMenus = function (menu_type, latitude, longitude, postcode, page_size, page_number) {
            var apiUrl = utilityService.stringFormat('/menu/delivery/{0}/{1}/{2}/{3}/{4}/{5}/{6}', fencingService.getCountry(), menu_type, latitude, longitude, postcode, page_size, page_number);
            return restService.get(apiUrl);
        };

        this.listMenusByIds = function (_ids, menu_type) {
            var apiUrl = utilityService.stringFormat('/menu/byids/{0}/{1}/{2}', fencingService.getCountry(), menu_type, _ids);
            return restService.get(apiUrl);
        };

        this.listMenus = function (menu_type) {
            var apiUrl = '/menu/all/' + fencingService.getCountry() + '/' + menu_type;
            return restService.get(apiUrl);
        };
    };

    menuService.$inject = ['fencingService', 'restService', 'utilityService'];
    return menuService;
});
