define([], function () {
    var merchantService = function (fencingService, restService, utilityService) {
        this.getMerchantById = function (_id) {
            var apiUrl = '/merchant/' + _id;
            return restService.get(apiUrl);
        };

        this.getMerchants = function (page_size, page_number) {
            var apiUrl = utilityService.stringFormat('/merchant/all/{0}/{1}/{2}', fencingService.getCountry(), page_size, page_number);
            return restService.get(apiUrl);
        };

        this.getMerchantsByIds = function (_ids, page_size, page_number) {
            var apiUrl = utilityService.stringFormat('/merchant/byids/{0}/{1}/{2}/{3}', fencingService.getCountry(), _ids.join(','), page_size, page_number);
            return restService.get(apiUrl);
        };
    };

    merchantService.$inject = ['fencingService', 'restService', 'utilityService'];
    return merchantService;
});