define([], function () {
    var notificationService = function ($q, $rootScope, $window, config_constants, keenService, localStorageService, userService, frameworkService) {
        var getDeviceUniqueId = function () {
            var deferred = $q.defer();
            $window.plugins.OneSignal.getIds(function (_ids) {
                userService.setUUID(_ids.userId);
                deferred.resolve();
            });
            return deferred.promise;
        };

        var onNotificationOpened = function (notification) {
            var additionalData = notification.payload.additionalData;
            keenService.recordEvent('notifications_open', additionalData);
            if (_.get(additionalData, 'state')) {
                frameworkService.navigateTo(additionalData.state, additionalData.params, { reload: true });
            }
        };

        this.init = function () {
            $window.plugins.OneSignal
                .startInit(config_constants.onesignal.appId, config_constants.onesignal.googleProjectNumber)
                .inFocusDisplaying($window.plugins.OneSignal.OSInFocusDisplayOption.Notification)
                .handleNotificationOpened(function (result) {
                    onNotificationOpened(result.notification);
                })
                .endInit();

            return getDeviceUniqueId();
        };

        this.getAdvertNotificationsState = function () {
            var isEnabled = localStorageService.retrieve('advertNotifications');
            return _.isBoolean(isEnabled) ? isEnabled : true;
        };

        this.setAdvertNotificationsState = function (enable) {
            localStorageService.store('advertNotifications', enable);
        };
    };
    notificationService.$inject = ['$q', '$rootScope', '$window', 'config_constants', 'keenService', 'localStorageService', 'userService', 'frameworkService'];
    return notificationService;
});
