define([], function () {
    var restService = function ($http, config_constants) {
        this.get = function (url) {
            url = url.replace(/\/undefined+/g, ''); // replaces '../undefined/' in URL with '/'
            return this.send('GET', url);
        };

        this.post = function (url, data) {
            return this.send('POST', url, angular.toJson(data));
        };

        this.put = function (url, data) {
            return this.send('PUT', url, angular.toJson(data));
        };

        this.delete = function (url) {
            return this.send('DELETE', url);
        };

        this.send = function (method, url, data) {
            return $http({
                method: method,
                url: config_constants.baseAPIUrl + url,
                data: data
            });
        };
    };

    restService.$inject = ['$http', 'config_constants'];
    return restService;
});
