define([], function () {
    var reviewUtilService = function (localStorageService, fencingService, utilityService) {
        var review = localStorageService.retrieve('review') || {};
        var goReviewFields = localStorageService.retrieve('goReviewFields') || {};

        // Save it in memory as a singleton so it can be shared in more than one controller at a time
        this.getReview = function () {
            return review;
        };

        this.setReview = function (data) {
            review = data;
            localStorageService.store('review', data);
        };

        this.clearReview = function () {
            review = {};
            localStorageService.remove('review');
        };

        this.getGoReviewFields = function () {
            return goReviewFields;
        };

        this.setGoReviewFields = function (data) {
            goReviewFields = data;
            localStorageService.store('goReviewFields', data);
        };

        this.clearGoReviewFields = function () {
            goReviewFields = {};
            localStorageService.remove('goReviewFields');
        };
    };

    reviewUtilService.$inject = ['localStorageService', 'fencingService', 'utilityService'];
    return reviewUtilService;
});
